************************************************************************
* sanc_cc_v1.50 package.
************************************************************************
* File (cc-qcd_br_1413_43.f) created on Thu Jan 19 01:32:39 MSK 2012.
************************************************************************
* This is the FORTRAN module (cc_qcd_br_1413_43) to calculate QCD soft
* gluon radiation cross section for the anti-dn + up -> H   + W^+ process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2012.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_qcd_br_1413_43 (qs,ts,us,born,soft,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 jbwhwsq
      real*8 sqrtlswh
      real*8 betaswh,ibetaswh
      real*8 pxxswjh,ipxxswjh
      complex*16 propws,propiws,propwsc

      s = -qs
      t = -ts
      u = -us

      sqrtlswh = dsqrt((s-mw**2-mh**2)**2-4d0*mw**2*mh**2)
      cosf = (u-t)/sqrtlswh
      sinf = dsqrt(1d0-cosf**2)

      propiws = (rwm2-s)
      propws = 1d0/propiws
      propwsc = dconjg(propws)

      born=
     & +propws*propwsc*sqrtlswh/pi*g**4*(1d0/3072-1d0/1536*mh**2/s+1d0/3
     & 072*mh**4/s**2+1d0/512*mw**2/s-1d0/1536*mw**2*mh**2/s**2+1d0/3072
     & *mw**4/s**2)
     & +propws*propwsc*sqrtlswh*cosf**2/pi*g**4*(-1d0/3072+1d0/1536*mh**
     & 2/s-1d0/3072*mh**4/s**2+1d0/1536*mw**2/s+1d0/1536*mw**2*mh**2/s**
     & 2-1d0/3072*mw**4/s**2)

      born = born*conhc
      virt = 0d0
      soft = 0d0
      hard = 0d0

      if (iborn.eq.1) return

      softvirt=
     & +born/pi*alphas*cf*(3d0/2-3d0/2*log(s/thmu2))
     & +log(1d0/mup**2*s)*born/pi*alphas*cf*(3d0/4)
     & +log(1d0/mdn**2*s)*born/pi*alphas*cf*(3d0/4)
     & +log(4*omega**2/s)*born/pi*alphas*cf*(-1)
     & +log(4*omega**2/s)*log(1d0/mup**2*s)*born/pi*alphas*cf*(1d0/2)
     & +log(4*omega**2/s)*log(1d0/mdn**2*s)*born/pi*alphas*cf*(1d0/2)
     & +ddilog(1d0)*born/pi*alphas*cf*(2)

      soft = softvirt

      return
      end
