************************************************************************
* sanc_cc_v1.40 package.
************************************************************************
* File (cc_ff_2122_1516.F) is created on Tue Aug  9 22:38:45 MSD 2011.
************************************************************************
* This is the FORTRAN module (cc_ff_2122_1516) to calculate 1-loop EW
* form factors for the anti-tp -> anti-bt + mn + mo^- decay.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2011.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ff_2122_1516 (qs,ts,us)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      complex*16 ff_ew_ll,ff_ew_rl,ff_ew_ldl,ff_ew_rdl

      real*8 a0fw,a0fz,a0fh,a0ftp
      complex*16 b0ptpztp,b0ptphtp,b0ptpcw
      complex*16 b0fqswz,b0fqswh,b0fqswc,b0ftpwc,b0ftpztp,b0ftstpc,b0ft
     & scc,b0ftphtp,b0fqstpc,b0fqscc
      complex*16 c0ctptscwc,c0ctptscztp,c0ctpqswtpz,c0ctpqszcw,c0ctpusc
     & ztp,c0ccqswcz,c0cctscwtp,c0cctsczc,c0ccuscwtp,c0ctpqswtph,c0ctpqs
     & wtpc,c0ctpqscztp,c0ccqsczc
      complex*16 d0tpcccqstswczc,d0tpcccqstsztpwc,d0tpcccqsuswczc,d0tpc
     & ccqsusztpwc
      complex*16 jawsubsubqstsctpw,jawsubsubqsustpcw
      real*8 sdet3ictpts,sdet3ictpqs
      real*8 invftpw
      complex*16 propwqs,propiwqs

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

      propiwqs = (rwm2+qs)
      propwqs = 1d0/propiwqs
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      a0ftp = log(rtpm2/thmu2) - 1d0
      b0ptpztp = b0p(-rtpm2,zm2,tpm2)
      b0ptphtp = b0p(-rtpm2,hm2,tpm2)
      b0ptpcw = b0p(-rtpm2,cm2,wm2)
      b0fqswz = b0f(qs,thmu2,wm2,zm2)
      b0fqswh = b0f(qs,thmu2,wm2,hm2)
      b0fqswc = b0f(qs,thmu2,mw2,cm2)
      b0ftpwc = b0f(-rtpm2,thmu2,wm2,cm2)
      b0ftpztp = b0f(-rtpm2,thmu2,zm2,tpm2)
      b0ftstpc = b0f(ts,thmu2,tpm2,cm2)
      b0ftscc = b0f(ts,thmu2,cm2,cm2)
      b0ftphtp = b0f(-rtpm2,thmu2,hm2,tpm2)
      b0fqstpc = b0f(qs,thmu2,tpm2,cm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      c0ctptscwc = -c0(0d0,rtpm2,-ts,0d0,rwm2,0d0)
      c0ctptscztp = -c0(0d0,rtpm2,-ts,0d0,rzm2,rtpm2)
      c0ctpqswtpz = -c0(0d0,rtpm2,-qs,rwm2,rtpm2,rzm2)
      c0ctpqszcw = -c0(0d0,rtpm2,-qs,rzm2,0d0,rwm2)
      c0ctpuscztp = -c0(0d0,rtpm2,-us,0d0,rzm2,rtpm2)
      c0ccqswcz = -c0(0d0,0d0,-qs,rwm2,0d0,rzm2)
      c0cctscwtp = -c0(0d0,0d0,-ts,0d0,rwm2,rtpm2)
      c0cctsczc = -c0(0d0,0d0,-ts,0d0,rzm2,0d0)
      c0ccuscwtp = -c0(0d0,0d0,-us,0d0,rwm2,rtpm2)
      c0ctpqswtph = -c0(0d0,rtpm2,-qs,rwm2,rtpm2,rhm2)
      c0ctpqswtpc = c000(0d0,-rtpm2,qs,mw2,tpm2,cm2)
      c0ctpqscztp = -c0(0d0,rtpm2,-qs,0d0,rzm2,rtpm2)
      c0ccqsczc = -c0(0d0,0d0,-qs,0d0,rzm2,0d0)
      d0tpcccqstswczc =
     & d0(rtpm2,0d0,0d0,0d0,-qs,-ts,rwm2,0d0,rzm2,0d0)
      d0tpcccqstsztpwc =
     & d0(rtpm2,0d0,0d0,0d0,-qs,-ts,rzm2,rtpm2,rwm2,0d0)
      d0tpcccqsuswczc =
     & d0(rtpm2,0d0,0d0,0d0,-qs,-us,rwm2,0d0,rzm2,0d0)
      d0tpcccqsusztpwc =
     & d0(rtpm2,0d0,0d0,0d0,-qs,-us,rzm2,rtpm2,rwm2,0d0)
      jawsubsubqstsctpw = jaw_tbud_subsub1(qs,ts,cm2,tpm2,mw2)
      jawsubsubqsustpcw = jaw_tbud_subsub2(qs,us,tpm2,cm2,mw2)
      sdet3ictpts = 1d0/(ts+(mtp)**2)
      sdet3ictpqs = 1d0/(qs+(mtp)**2)
      invftpw = 1d0/(1d0-rtpm2/rwm2)

      ff_ew_ll=
     & +propwqs*a0fw*(-1d0/12/ctw**2*mw**2-1d0/12*mh**2-5*mw**2+3*mw**4/
     & mh**2)
     & +propwqs*a0fz*(1d0/12/ctw**4*mw**2+3d0/2/ctw**4*mw**4/mh**2+2d0/3
     & /ctw**2*mw**2-2*mw**2)
     & +propwqs*a0fh*(1d0/12/mw**2*mh**4+1d0/2*mh**2)
     & +propwqs*b0fqswz*(1d0/12/ctw**4*mw**2+4d0/3/ctw**2*mw**2-17d0/3*m
     & w**2-4*ctw**2*mw**2)
     & +propwqs*b0fqswh*(1d0/12/mw**2*mh**4-1d0/3*mh**2+mw**2)
     & +propwqs*b0fqswc*(-4*mw**2+4*ctw**2*mw**2)
     & +propwqs*(1d0/ctw**4*mw**4/mh**2-1d0/6/ctw**2*mw**2-1d0/6*mh**2-6
     & 4d0/9*mw**2-mw**2*zmwzwbos+2*mw**4/mh**2)
     & +propiwqs*sdet3ictpts*c0ctptscwc*(1d0/2/ctw**2*vpamo*vpabt/us*mw*
     & *2*mtp**2+2d0/3/us*mw**2*mtp**2-2d0/3*ctw**2/us*mw**2*mtp**2)
     & +propiwqs*sdet3ictpts*c0ctptscztp*(1d0/2/ctw**4*vpamn*vpatp/us*mw
     & **2*mtp**2)
     & +propiwqs*sdet3ictpts*b0ftpwc*(1d0/2/ctw**2*vpamo*vpabt/us*mtp**2
     & +2d0/3/us*mtp**2-2d0/3*ctw**2/us*mtp**2)
     & +propiwqs*sdet3ictpts*b0ftpztp*(1d0/2/ctw**2*vpamn*vpatp/us*mtp**
     & 2)
     & +propiwqs*sdet3ictpts*b0ftstpc*(-1d0/2/ctw**2*vpamn*vpatp/us*mtp*
     & *2)
     & +propiwqs*sdet3ictpts*b0ftscc*(-1d0/2/ctw**2*vpamo*vpabt/us*mtp**
     & 2-2d0/3/us*mtp**2+2d0/3*ctw**2/us*mtp**2)
     & +propiwqs*d0tpcccqstswczc*(-1d0/4/ctw**6*vpamo*vpabt/us**2*mw**4*
     & mtp**2-1d0/4/ctw**6*vpamo*vpabt*ts/us**2*mw**4-1d0/4/ctw**4*vpamo
     & *vpabt/qs/us*mw**4*mtp**2-1d0/4/ctw**4*vpamo*vpabt/qs*mw**2*mtp**
     & 2-1d0/2/ctw**4*vpamo*vpabt/us*mw**4+1d0/2/ctw**4*vpamo*vpabt*ts/u
     & s**2*mw**2*mtp**2-1d0/2/ctw**4*vpamo*vpabt*ts/us**2*mw**4+1d0/2/c
     & tw**4*vpamo*vpabt*ts**2/us**2*mw**2+1d0/4/ctw**2*vpamo*vpabt/qs/u
     & s**2*mw**4*mtp**4+1d0/4/ctw**2*vpamo*vpabt/qs/us*mw**2*mtp**4+1d0
     & /4/ctw**2*vpamo*vpabt/qs/us*mw**4*mtp**2+1d0/4/ctw**2*vpamo*vpabt
     & /qs*mw**2*mtp**2+1d0/4/ctw**2*vpamo*vpabt/us**2*mw**4*mtp**2+1d0/
     & 4/ctw**2*vpamo*vpabt/us*mw**2*mtp**2-1d0/4/ctw**2*vpamo*vpabt*ts/
     & us**2*mw**4-1d0/4/ctw**2*vpamo*vpabt*ts-1d0/4/ctw**2*vpamo*vpabt*
     & ts**2/us**2*mtp**2+1d0/2/ctw**2*vpamo*vpabt*ts**2/us**2*mw**2-1d0
     & /4/ctw**2*vpamo*vpabt*ts**3/us**2)
     & +propiwqs*d0tpcccqstsztpwc*(1d0/4/ctw**6*vpamn*vpatp/qs/us**2*mw*
     & *4*mtp**4+1d0/4/ctw**6*vpamn*vpatp/qs/us*mw**4*mtp**2+1d0/4/ctw**
     & 6*vpamn*vpatp/us**2*mw**4*mtp**2-1d0/4/ctw**6*vpamn*vpatp*ts/us**
     & 2*mw**4-1d0/4/ctw**4*vpamn*vmatp/qs/us*mw**2*mtp**4-1d0/4/ctw**4*
     & vpamn*vmatp/qs*mw**2*mtp**2-1d0/4/ctw**4*vpamn*vmatp/us*mw**2*mtp
     & **2+1d0/4/ctw**4*vpamn*vpatp/qs/us*mw**2*mtp**4-1d0/4/ctw**4*vpam
     & n*vpatp/qs/us*mw**4*mtp**2+1d0/4/ctw**4*vpamn*vpatp/qs*mw**2*mtp*
     & *2+1d0/2/ctw**4*vpamn*vpatp/us*mw**2*mtp**2-1d0/2/ctw**4*vpamn*vp
     & atp/us*mw**4+1d0/2/ctw**4*vpamn*vpatp*ts/us**2*mw**2*mtp**2-1d0/2
     & /ctw**4*vpamn*vpatp*ts/us**2*mw**4+1d0/2/ctw**4*vpamn*vpatp*ts**2
     & /us**2*mw**2+1d0/4/ctw**2*vpamn*vmatp/qs*mw**2*mtp**2+1d0/4/ctw**
     & 2*vpamn*vmatp/us*mtp**4-1d0/4/ctw**2*vpamn*vmatp/us*mw**2*mtp**2+
     & 1d0/4/ctw**2*vpamn*vmatp*ts/us*mtp**2-1d0/4/ctw**2*vpamn*vpatp/qs
     & *mw**2*mtp**2-1d0/4/ctw**2*vpamn*vpatp/us**2*mtp**6+1d0/2/ctw**2*
     & vpamn*vpatp/us**2*mw**2*mtp**4-1d0/4/ctw**2*vpamn*vpatp/us**2*mw*
     & *4*mtp**2-1d0/4/ctw**2*vpamn*vpatp/us*mtp**4+1d0/4/ctw**2*vpamn*v
     & patp/us*mw**2*mtp**2-1d0/4/ctw**2*vpamn*vpatp*mtp**2-3d0/4/ctw**2
     & *vpamn*vpatp*ts/us**2*mtp**4+1d0/ctw**2*vpamn*vpatp*ts/us**2*mw**
     & 2*mtp**2-1d0/4/ctw**2*vpamn*vpatp*ts/us**2*mw**4-1d0/4/ctw**2*vpa
     & mn*vpatp*ts/us*mtp**2-1d0/4/ctw**2*vpamn*vpatp*ts-3d0/4/ctw**2*vp
     & amn*vpatp*ts**2/us**2*mtp**2+1d0/2/ctw**2*vpamn*vpatp*ts**2/us**2
     & *mw**2-1d0/4/ctw**2*vpamn*vpatp*ts**3/us**2)
     & +propiwqs*d0tpcccqsuswczc*(-1d0/2/ctw**2*vpamn*vpabt*mtp**2-1d0/2
     & /ctw**2*vpamn*vpabt*ts-1d0/2/ctw**2*vpamn*vpabt*qs)
     & +propiwqs*d0tpcccqsusztpwc*(-1d0/4/ctw**4*vpamo*vmatp/qs*mw**2*mt
     & p**2+1d0/4/ctw**2*vpamo*vmatp/qs/us*mw**2*mtp**4+1d0/4/ctw**2*vpa
     & mo*vmatp/qs*mw**2*mtp**2+1d0/4/ctw**2*vpamo*vmatp/us*mtp**4+1d0/4
     & /ctw**2*vpamo*vmatp*mtp**2-1d0/2/ctw**2*vpamo*vpatp*ts-1d0/2/ctw*
     & *2*vpamo*vpatp*qs)
     & +propiwqs*c0ctpqswtpz*(1d0/4/ctw**4*vpamn*vpatp/qs/us**2*mw**2*mt
     & p**4+1d0/4/ctw**4*vpamn*vpatp/us**2*mw**2*mtp**2-1d0/4/ctw**4*vpa
     & mn*vpatp/us*mw**2-1d0/4/ctw**4*vpamn*vpatp*ts/us**2*mw**2+1d0/4/c
     & tw**2*vpamo*vmatp/qs/us*mtp**4+1d0/4/ctw**2*vpamo*vmatp/us*mtp**2
     & -1d0/2/ctw**2*vpamo*vpatp-1d0/4/ctw**2*vpamn*vmatp/qs/us*mtp**4-1
     & d0/4/ctw**2*vpamn*vmatp/us*mtp**2+1d0/4/ctw**2*vpamn*vpatp/qs/us*
     & mtp**4+1d0/2/ctw**2*vpamn*vpatp/us*mtp**2-1d0/4/ctw**2*vpamn*vpat
     & p/us*mw**2+1d0/4/ctw**2*vpamn*vpatp+1d0/4/ctw**2*vpamn*vpatp*ts/u
     & s**2*mtp**2-1d0/4/ctw**2*vpamn*vpatp*ts/us**2*mw**2+1d0/4/ctw**2*
     & vpamn*vpatp*ts**2/us**2)
     & +propiwqs*c0ctpqszcw*(-1d0/4/ctw**4*vpamo*vpabt/us*mw**2-1d0/4/ct
     & w**4*vpamo*vpabt*ts/us**2*mw**2+1d0/4/ctw**2*vpamo*vpabt/qs/us**2
     & *mw**2*mtp**4+1d0/4/ctw**2*vpamo*vpabt/qs/us*mtp**4+1d0/4/ctw**2*
     & vpamo*vpabt/us**2*mw**2*mtp**2+1d0/4/ctw**2*vpamo*vpabt/us*mtp**2
     & -1d0/4/ctw**2*vpamo*vpabt/us*mw**2+1d0/4/ctw**2*vpamo*vpabt-1d0/4
     & /ctw**2*vpamo*vpabt*ts/us**2*mw**2+1d0/4/ctw**2*vpamo*vpabt*ts**2
     & /us**2-1d0/2/ctw**2*vpamn*vpabt)
     & +propiwqs*c0ctptscwc*(1d0/4/ctw**4*vpamo*vpabt/us**2*mw**2*mtp**2
     & +1d0/4/ctw**4*vpamo*vpabt*ts/us**2*mw**2+1d0/4/ctw**2*vpamo*vpabt
     & /qs/us*mw**2*mtp**2+1d0/4/ctw**2*vpamo*vpabt/qs*mtp**2-1d0/4/ctw*
     & *2*vpamo*vpabt*ts/us**2*mtp**2+1d0/4/ctw**2*vpamo*vpabt*ts/us**2*
     & mw**2+1d0/4/ctw**2*vpamo*vpabt*ts/us-1d0/4/ctw**2*vpamo*vpabt*ts*
     & *2/us**2+1d0/3/qs/us*mw**2*mtp**2+1d0/3/qs*mtp**2-1d0/3*ts/us**2*
     & mtp**2+1d0/3*ts/us**2*mw**2+1d0/3*ts/us-1d0/3*ts**2/us**2-1d0/3*c
     & tw**2/qs/us*mw**2*mtp**2-1d0/3*ctw**2/qs*mtp**2+1d0/3*ctw**2*ts/u
     & s**2*mtp**2-1d0/3*ctw**2*ts/us**2*mw**2-1d0/3*ctw**2*ts/us+1d0/3*
     & ctw**2*ts**2/us**2)
     & +propiwqs*c0ctptscztp*(1d0/4/ctw**4*vpamn*vpatp/qs/us*mw**2*mtp**
     & 2+1d0/4/ctw**4*vpamn*vpatp*ts/us**2*mw**2-1d0/4/ctw**2*vpamn*vmat
     & p/qs*mtp**2+1d0/4/ctw**2*vpamn*vmatp/us*mtp**2+1d0/4/ctw**2*vpamn
     & *vpatp/qs*mtp**2-1d0/4/ctw**2*vpamn*vpatp/us**2*mtp**4+1d0/4/ctw*
     & *2*vpamn*vpatp/us**2*mw**2*mtp**2-1d0/2/ctw**2*vpamn*vpatp*ts/us*
     & *2*mtp**2+1d0/4/ctw**2*vpamn*vpatp*ts/us**2*mw**2+1d0/4/ctw**2*vp
     & amn*vpatp*ts/us-1d0/4/ctw**2*vpamn*vpatp*ts**2/us**2)
     & +propiwqs*c0ctpuscztp*(-1d0/4/ctw**2*vpamo*vmatp/qs/us*mtp**4-1d0
     & /4/ctw**2*vpamo*vmatp/qs*mtp**2)
     & +propiwqs*c0ccqswcz*(-1d0/4/ctw**4*vpamo*vpabt/us**2*mw**2*mtp**2
     & -1d0/4/ctw**4*vpamo*vpabt/us*mw**2-1d0/4/ctw**4*vpamo*vpabt*ts/us
     & **2*mw**2-1d0/4/ctw**4*vpamn*vpatp/us*mw**2-1d0/4/ctw**4*vpamn*vp
     & atp*ts/us**2*mw**2-1d0/4/ctw**2*vpamo*vpabt/us*mw**2+1d0/4/ctw**2
     & *vpamo*vpabt+1d0/4/ctw**2*vpamo*vpabt*ts/us**2*mtp**2-1d0/4/ctw**
     & 2*vpamo*vpabt*ts/us**2*mw**2+1d0/4/ctw**2*vpamo*vpabt*ts**2/us**2
     & -1d0/4/ctw**2*vpamo*vmatp/us*mtp**2-1d0/2/ctw**2*vpamo*vpatp-1d0/
     & 2/ctw**2*vpamn*vpabt-1d0/4/ctw**2*vpamn*vmatp/us*mtp**2+1d0/4/ctw
     & **2*vpamn*vpatp/us**2*mtp**4-1d0/4/ctw**2*vpamn*vpatp/us**2*mw**2
     & *mtp**2+1d0/4/ctw**2*vpamn*vpatp/us*mtp**2-1d0/4/ctw**2*vpamn*vpa
     & tp/us*mw**2+1d0/4/ctw**2*vpamn*vpatp+1d0/2/ctw**2*vpamn*vpatp*ts/
     & us**2*mtp**2-1d0/4/ctw**2*vpamn*vpatp*ts/us**2*mw**2+1d0/4/ctw**2
     & *vpamn*vpatp*ts**2/us**2)
     & +propiwqs*c0cctscwtp*(-1d0/4/ctw**4*vpamn*vpatp/qs/us**2*mw**2*mt
     & p**4-1d0/4/ctw**4*vpamn*vpatp/qs/us*mw**2*mtp**2-1d0/4/ctw**4*vpa
     & mn*vpatp/us**2*mw**2*mtp**2+1d0/4/ctw**4*vpamn*vpatp*ts/us**2*mw*
     & *2+1d0/4/ctw**2*vpamn*vmatp/qs/us*mtp**4+1d0/4/ctw**2*vpamn*vmatp
     & /qs*mtp**2+1d0/4/ctw**2*vpamn*vmatp/us*mtp**2-1d0/4/ctw**2*vpamn*
     & vpatp/qs/us*mtp**4-1d0/4/ctw**2*vpamn*vpatp/qs*mtp**2-1d0/4/ctw**
     & 2*vpamn*vpatp/us*mtp**2-1d0/4/ctw**2*vpamn*vpatp*ts/us**2*mtp**2+
     & 1d0/4/ctw**2*vpamn*vpatp*ts/us**2*mw**2+1d0/4/ctw**2*vpamn*vpatp*
     & ts/us-1d0/4/ctw**2*vpamn*vpatp*ts**2/us**2)
     & +propiwqs*c0cctsczc*(1d0/4/ctw**4*vpamo*vpabt*ts/us**2*mw**2-1d0/
     & 4/ctw**2*vpamo*vpabt/qs/us**2*mw**2*mtp**4-1d0/4/ctw**2*vpamo*vpa
     & bt/qs/us*mtp**4-1d0/4/ctw**2*vpamo*vpabt/qs/us*mw**2*mtp**2-1d0/4
     & /ctw**2*vpamo*vpabt/qs*mtp**2-1d0/4/ctw**2*vpamo*vpabt/us**2*mw**
     & 2*mtp**2-1d0/4/ctw**2*vpamo*vpabt/us*mtp**2+1d0/4/ctw**2*vpamo*vp
     & abt*ts/us**2*mw**2+1d0/4/ctw**2*vpamo*vpabt*ts/us-1d0/4/ctw**2*vp
     & amo*vpabt*ts**2/us**2)
     & +propiwqs*c0ccuscwtp*(1d0/4/ctw**2*vpamo*vmatp/qs*mtp**2-2d0/3/qs
     & *mtp**2+2d0/3*ctw**2/qs*mtp**2)
     & +propiwqs*a0fw*(-31d0/6/qs+3/qs*mw**2/mh**2)
     & +propiwqs*a0fz*(3d0/2/ctw**4/qs*mw**2/mh**2+1d0/12/ctw**2/qs-4d0/
     & 3/qs)
     & +propiwqs*b0fqswz*(5d0/6/ctw**2/qs-1d0/2/ctw**2*vpamo*vpabt/us-1d
     & 0/2/ctw**2*vpamn*vpatp/us-53d0/12/qs-14d0/3*ctw**2/qs)
     & +propiwqs*b0fqswh*(11d0/12/qs)
     & +propiwqs*b0fqswc*(-14d0/3/qs-2d0/3/us+14d0/3*ctw**2/qs+2d0/3*ctw
     & **2/us)
     & +propiwqs*b0ftstpc*(1d0/2/ctw**2*vpamn*vpatp/us)
     & +propiwqs*b0ftscc*(1d0/2/ctw**2*vpamo*vpabt/us+2d0/3/us-2d0/3*ctw
     & **2/us)
     & +propiwqs*(1d0/ctw**4/qs*mw**2/mh**2-1d0/6/ctw**2/qs-64d0/9/qs+2/
     & qs*mw**2/mh**2)
     & +sdet3ictpqs**2*c0ctpqswtpz*(1d0/4*vmatp/mw**2*mtp**8-1d0/2*vmatp
     & *mtp**6+1d0/4*vmatp*mw**2*mtp**4-1d0/4*vpatp/mw**2*mtp**8-1d0/2*v
     & patp*mtp**6+7d0/4*vpatp*mw**2*mtp**4-vpatp*mw**4*mtp**2)
     & +sdet3ictpqs**2*c0ctpqswtph*(-1d0/4/mw**2*mtp**8+1d0/2*mtp**6-1d0
     & /4*mw**2*mtp**4)
     & +sdet3ictpqs**2*c0ctpqswtpc*(-4d0/3*mtp**6+8d0/3*mw**2*mtp**4-4d0
     & /3*mw**4*mtp**2+4d0/3*ctw**2*mtp**6-8d0/3*ctw**2*mw**2*mtp**4+4d0
     & /3*ctw**2*mw**4*mtp**2)
     & +sdet3ictpqs**2*c0ctpqszcw*(1d0/ctw**4*vpabt*mw**4*mtp**2)
     & +sdet3ictpqs**2*c0ctpqscztp*(1d0/2/ctw**6*vpatp*vpabt*mw**4*mtp**
     & 2)
     & +sdet3ictpqs**2*a0ftp*(4d0/3*mtp**4-4d0/3*mw**2*mtp**2-4d0/3*ctw*
     & *2*mtp**4+4d0/3*ctw**2*mw**2*mtp**2)
     & +sdet3ictpqs**2*b0ftpwc*(-1d0/ctw**2*vpabt*mw**2*mtp**2)
     & +sdet3ictpqs**2*b0ftpztp*(1d0/2/ctw**4*vpatp*vpabt*mw**2*mtp**2+1
     & d0/4*vmatp/mw**2*mtp**6-1d0/4*vmatp*mtp**4-1d0/4*vpatp/mw**2*mtp*
     & *6-3d0/4*vpatp*mtp**4+vpatp*mw**2*mtp**2)
     & +sdet3ictpqs**2*b0ftphtp*(-1d0/4/mw**2*mtp**6+1d0/4*mtp**4)
     & +sdet3ictpqs**2*b0fqswz*(1d0/ctw**2*vpabt*mw**2*mtp**2-1d0/4*vmat
     & p/mw**2*mtp**6+1d0/4*vmatp*mtp**4+1d0/4*vpatp/mw**2*mtp**6+3d0/4*
     & vpatp*mtp**4-vpatp*mw**2*mtp**2)
     & +sdet3ictpqs**2*b0fqswh*(1d0/4/mw**2*mtp**6-1d0/4*mtp**4)
     & +sdet3ictpqs**2*b0fqswc*(4d0/3*mtp**4-4d0/3*mw**2*mtp**2-4d0/3*ct
     & w**2*mtp**4+4d0/3*ctw**2*mw**2*mtp**2)
     & +sdet3ictpqs**2*b0fqstpc*(-1d0/2/ctw**4*vpatp*vpabt*mw**2*mtp**2)
     & +sdet3ictpqs**2*(-4d0/3*mtp**4+4d0/3*mw**2*mtp**2+4d0/3*ctw**2*mt
     & p**4-4d0/3*ctw**2*mw**2*mtp**2)
     & +sdet3ictpqs*c0ctpqswtpz*(-1d0/4/ctw**2*vmatp*mtp**4+1d0/4/ctw**2
     & *vmatp*mw**2*mtp**2-1d0/4/ctw**2*vpatp*mtp**4-3d0/4/ctw**2*vpatp*
     & mw**2*mtp**2+1d0/ctw**2*vpatp*mw**4-1d0/2*vmatp/mw**2*mtp**6+vmat
     & p*mtp**4-1d0/2*vmatp*mw**2*mtp**2+1d0/2*vpatp/mw**2*mtp**6-1d0/2*
     & vpatp*mw**2*mtp**2)
     & +sdet3ictpqs*c0ctpqswtph*(1d0/2/mw**2*mtp**6-1d0/4/mw**2*mh**2*mt
     & p**4+1d0/4*mh**2*mtp**2-1d0/2*mw**2*mtp**2)
     & +sdet3ictpqs*c0ctpqswtpc*(4d0/3*mtp**4-4d0/3*mw**2*mtp**2-4d0/3*c
     & tw**2*mtp**4+4d0/3*ctw**2*mw**2*mtp**2)
     & +sdet3ictpqs*c0ctpqszcw*(-1d0/2/ctw**4*vpabt*mw**2*mtp**2-1d0/ctw
     & **2*vpabt*mw**4)
     & +sdet3ictpqs*c0ctpqscztp*(-1d0/2/ctw**6*vpatp*vpabt*mw**4-1d0/2/c
     & tw**4*vpatp*vpabt*mw**2*mtp**2)
     & +sdet3ictpqs*a0fw*(1d0/8*mtp**2+2d0/3*mw**2-1d0/8*vmatp*mtp**2+1d
     & 0/8*vpatp*mtp**2+1d0/2*vpatp*mw**2-2d0/3*ctw**2*mw**2)
     & +sdet3ictpqs*a0fz*(1d0/4/ctw**4*vpatp*vpabt*mw**2-1d0/2/ctw**2*vp
     & abt*mw**2)
     & +sdet3ictpqs*a0ftp*(-1d0/8/mw**2*mtp**4-10d0/9*mtp**2+1d0/8*vmatp
     & /mw**2*mtp**4-1d0/8*vpatp/mw**2*mtp**4-1d0/2*vpatp*mtp**2+10d0/9*
     & ctw**2*mtp**2)
     & +sdet3ictpqs*b0ftpwc*(1d0/2/ctw**2*vpabt*mtp**2-1d0/3*mtp**2-1d0/
     & 3*mw**2+1d0/2*vpabt*mtp**2+1d0/2*vpabt*mw**2+1d0/3*ctw**2*mtp**2+
     & 1d0/3*ctw**2*mw**2)
     & +sdet3ictpqs*b0ftpztp*(-1d0/4/ctw**4*vpatp*vpabt*mw**2-3d0/8/ctw*
     & *2*vmatp*mtp**2-1d0/8/ctw**2*vpatp*mtp**2-1d0/2/ctw**2*vpatp*mw**
     & 2-1d0/2/ctw**2*vpatp*vpabt*mtp**2-1d0/4*vmatp/mw**2*mtp**4+1d0/2*
     & vmatp*mtp**2+1d0/4*vpatp/mw**2*mtp**4-1d0/2*vpatp*mtp**2)
     & +sdet3ictpqs*b0ftphtp*(1d0/4/mw**2*mtp**4-1d0/8/mw**2*mh**2*mtp**
     & 2+1d0/2*mtp**2)
     & +sdet3ictpqs*b0fqswz*(-1d0/2/ctw**2*vpabt*mtp**2-1d0/2/ctw**2*vpa
     & bt*mw**2+3d0/8/ctw**2*vmatp*mtp**2+1d0/8/ctw**2*vpatp*mtp**2+1d0/
     & 2/ctw**2*vpatp*mw**2-1d0/2*vpabt*mtp**2-1d0/2*vpabt*mw**2+3d0/8*v
     & matp/mw**2*mtp**4-5d0/8*vmatp*mtp**2-3d0/8*vpatp/mw**2*mtp**4+1d0
     & /8*vpatp*mtp**2+1d0/2*vpatp*mw**2)
     & +sdet3ictpqs*b0fqswh*(-3d0/8/mw**2*mtp**4+1d0/8/mw**2*mh**2*mtp**
     & 2-3d0/8*mtp**2)
     & +sdet3ictpqs*b0fqswc*(-1d0/3*mtp**2+mw**2+1d0/3*ctw**2*mtp**2-ctw
     & **2*mw**2)
     & +sdet3ictpqs*b0fqstpc*(1d0/2/ctw**4*vpatp*vpabt*mw**2+1d0/2/ctw**
     & 2*vpatp*vpabt*mtp**2-4d0/9*mtp**2+4d0/9*ctw**2*mtp**2)
     & +sdet3ictpqs*(4d0/9*mtp**2-4d0/9*ctw**2*mtp**2)
     & +jawsubsubqstsctpw*(1d0/3/qs/us**2*mw**4*mtp**4+1d0/3/qs/us*mw**2
     & *mtp**4+1d0/3/qs/us*mw**4*mtp**2+1d0/3/qs*mw**2*mtp**2+1d0/3/us**
     & 2*mw**4*mtp**2+1d0/3/us*mw**2*mtp**2-1d0/3*ts/us**2*mw**4-1d0/3*t
     & s-1d0/3*ts**2/us**2*mtp**2+2d0/3*ts**2/us**2*mw**2-1d0/3*ts**3/us
     & **2-1d0/3*ctw**2/qs/us**2*mw**4*mtp**4-1d0/3*ctw**2/qs/us*mw**2*m
     & tp**4-1d0/3*ctw**2/qs/us*mw**4*mtp**2-1d0/3*ctw**2/qs*mw**2*mtp**
     & 2-1d0/3*ctw**2/us**2*mw**4*mtp**2-1d0/3*ctw**2/us*mw**2*mtp**2+1d
     & 0/3*ctw**2*ts/us**2*mw**4+1d0/3*ctw**2*ts+1d0/3*ctw**2*ts**2/us**
     & 2*mtp**2-2d0/3*ctw**2*ts**2/us**2*mw**2+1d0/3*ctw**2*ts**3/us**2)
     & 
     & +jawsubsubqsustpcw*(-2d0/3/qs/us*mw**2*mtp**4-2d0/3/qs*mw**2*mtp*
     & *2-2d0/3/us*mtp**4-2d0/3*mtp**2+4d0/3*ts+4d0/3*qs+2d0/3*ctw**2/qs
     & /us*mw**2*mtp**4+2d0/3*ctw**2/qs*mw**2*mtp**2+2d0/3*ctw**2/us*mtp
     & **4+2d0/3*ctw**2*mtp**2-4d0/3*ctw**2*ts-4d0/3*ctw**2*qs)
     & +c0ctpqswtpz*(1d0/2/ctw**2*vpatp*mtp**2-1d0/ctw**2*vpatp*mw**2+1d
     & 0/4*vmatp/mw**2*mtp**4-3d0/2*vmatp*mtp**2-1d0/4*vpatp/mw**2*mtp**
     & 4+1d0/2*vpatp*mtp**2-vpatp*mw**2)
     & +c0ctpqswtph*(-1d0/4/mw**2*mtp**4+1d0/2*mtp**2)
     & +c0ctpqswtpc*(-2d0/3/qs/us*mw**2*mtp**4-2d0/3/us*mw**2*mtp**2-2d0
     & /3*mtp**2+2d0/3*ts/us*mtp**2+4d0/3*qs+2d0/3*ctw**2/qs/us*mw**2*mt
     & p**4+2d0/3*ctw**2/us*mw**2*mtp**2+2d0/3*ctw**2*mtp**2-2d0/3*ctw**
     & 2*ts/us*mtp**2-4d0/3*ctw**2*qs)
     & +c0ctpqszcw*(1d0/ctw**2*vpabt*mw**2-vpabt*mtp**2+vpabt*mw**2)
     & +c0ctpqscztp*(1d0/ctw**4*vpatp*vpabt*mw**2-1d0/2/ctw**2*vpatp*vpa
     & bt*mtp**2-1d0/2/ctw**2*vpatp*vpabt*qs)
     & +c0ccqswcz*(-1d0/ctw**2*vpamo/qs*mw**4+1d0/ctw**2*vpamo*mw**2+1d0
     & /ctw**2*vpamn/qs*mw**4-1d0/ctw**2*vpamn*mw**2+vpamo*mw**2-vpamn*m
     & w**2)
     & +c0ccqsczc*(-1d0/2/ctw**6*vpamn*vpamo/qs*mw**4+1d0/ctw**4*vpamn*v
     & pamo*mw**2-1d0/2/ctw**2*vpamn*vpamo*qs)
     & +a0fw*(175d0/24+1d0/12/ctw**2/qs*mw**2+1d0/12/qs*mh**2+6/qs*mw**2
     & -3/qs*mw**4/mh**2-3*mw**2/mh**2-1d0/2*vpamo/qs*mw**2+vpamo+1d0/2*
     & vpamn/qs*mw**2-vpamn-ctw**2/qs*mw**2+2*ctw**2-11d0/24*invftpw-inv
     & ftpw*vpatp+4d0/3*invftpw*ctw**2-3d0/8*invftpw**2)
     & +a0fz*(4d0/3-1d0/12/ctw**4/qs*mw**2-3d0/2/ctw**4/qs*mw**4/mh**2-3
     & d0/2/ctw**4*mw**2/mh**2-1d0/8/ctw**4*vmatp**2*mw**2/mtp**2+1d0/2/
     & ctw**4*vpamn*vpamo/qs*mw**2-2d0/3/ctw**2/qs*mw**2-1d0/12/ctw**2+1
     & d0/8/ctw**2*vpabt**2-1d0/16/ctw**2*vmatp**2-1d0/2/ctw**2*vpatp*vp
     & abt+1d0/8/ctw**2*vpatp*vmatp-1d0/16/ctw**2*vpatp**2-1d0/2/ctw**2*
     & vpamo/qs*mw**2+1d0/8/ctw**2*vpamo**2+1d0/2/ctw**2*vpamn/qs*mw**2-
     & 1d0/ctw**2*vpamn*vpamo+1d0/8/ctw**2*vpamn**2+2/qs*mw**2+vpabt+vpa
     & mo-vpamn)
     & +a0fh*(-1d0/12/qs/mw**2*mh**4+1d0/12/qs*mh**2-1d0/16/mw**2*mh**2)
     & +a0ftp*(-23d0/18+2d0/9/ctw**2+3d0/16/mw**2*mtp**2+1d0/16*vmatp**2
     & /mw**2*mtp**2-vpatp-1d0/8*vpatp*vmatp/mw**2*mtp**2+1d0/16*vpatp**
     & 2/mw**2*mtp**2+14d0/9*ctw**2+11d0/24*invftpw+invftpw*vpatp-4d0/3*
     & invftpw*ctw**2+3d0/8*invftpw**2)
     & +b0ftpwc*(7d0/24-vpabt-2d0/3*ctw**2)
     & +b0ftpztp*(-1d0/8/ctw**4*vmatp**2*mw**2/mtp**2+1d0/16/ctw**2*vmat
     & p**2+1d0/2/ctw**2*vpatp*vpabt+1d0/8/ctw**2*vpatp*vmatp-3d0/16/ctw
     & **2*vpatp**2+vpatp)
     & +b0ftphtp*(-1d0/16/mw**2*mh**2)
     & +b0fqswz*(13d0/3-1d0/12/ctw**4/qs*mw**2-4d0/3/ctw**2/qs*mw**2-5d0
     & /6/ctw**2-1d0/2/ctw**2*vpamo/qs*mw**2+1d0/2/ctw**2*vpamn/qs*mw**2
     & +17d0/3/qs*mw**2+1d0/2*vpabt-1d0/8*vmatp/mw**2*mtp**2+1d0/8*vpatp
     & /mw**2*mtp**2-1d0/2*vpatp-1d0/2*vpamo/qs*mw**2+1d0/2*vpamo+1d0/2*
     & vpamn/qs*mw**2-1d0/2*vpamn+4*ctw**2/qs*mw**2+8*ctw**2)
     & +b0fqswh*(-1-1d0/12/qs/mw**2*mh**4+1d0/6/qs*mh**2-1d0/qs*mw**2+1d
     & 0/8/mw**2*mtp**2)
     & +b0fqswc*(6+5/qs*mw**2-5*ctw**2/qs*mw**2-6*ctw**2)
     & +b0fqstpc*(2d0/3-3d0/4/ctw**2*vpatp*vpabt-2d0/3*ctw**2)
     & +b0fqscc*(1d0/2/ctw**4*vpamn*vpamo/qs*mw**2-3d0/4/ctw**2*vpamn*vp
     & amo)
     & +dreal(b0ptpztp)*(-1d0/8/ctw**4*vmatp**2*mw**2-1d0/8/ctw**4*vpatp
     & **2*mw**2+1d0/8/ctw**2*vmatp**2*mtp**2-3d0/4/ctw**2*vpatp*vmatp*m
     & tp**2+1d0/8/ctw**2*vpatp**2*mtp**2)
     & +dreal(b0ptphtp)*(1d0/2/mw**2*mtp**4-1d0/8/mw**2*mh**2*mtp**2)
     & +dreal(b0ptpcw)*(1d0/8/mw**2*mtp**4+1d0/8*mtp**2-1d0/4*mw**2)
     & +121d0/9+1d0/stw**2*ctw**2*deltarhofer+1d0/stw**2*ctw**2*deltarho
     & bos-1d0/ctw**4/qs*mw**4/mh**2-1d0/ctw**4*mw**2/mh**2+1d0/6/ctw**2
     & /qs*mw**2+1d0/6/ctw**2+3d0/16/ctw**2*vpabt**2-1d0/2/ctw**2*vpatp*
     & vpabt+1d0/8/ctw**2*vpatp**2+3d0/16/ctw**2*vpamo**2-1d0/2/ctw**2*v
     & pamn*vpamo+3d0/16/ctw**2*vpamn**2+64d0/9/qs*mw**2-2/qs*mw**4/mh**
     & 2+1d0/16/mw**2*mtp**2+caldwfer-za1fer-za1bos-2*mw**2/mh**2-1d0/8*
     & vmatp/mw**2*mtp**2+1d0/8*vpatp/mw**2*mtp**2-11d0/9*ctw**2+3d0/8*i
     & nvftpw

      ff_ew_rl=
     & 0

      ff_ew_ldl=
     & +propiwqs*sdet3ictpqs*c0ctpqswtpz*(1d0/2/ctw**2*vpamn*vpatp/us*mt
     & p**3-1d0/2/ctw**2*vpamn*vpatp/us*mw**2*mtp)
     & +propiwqs*sdet3ictpqs*c0ctpqszcw*(-1d0/2/ctw**4*vpamo*vpabt/us*mw
     & **2*mtp)
     & +propiwqs*sdet3ictpqs*b0ftpwc*(1d0/2/ctw**2*vpamo*vpabt/us*mtp+2d
     & 0/3/us*mtp-2d0/3*ctw**2/us*mtp)
     & +propiwqs*sdet3ictpqs*b0ftpztp*(1d0/2/ctw**2*vpamn*vpatp/us*mtp)
     & +propiwqs*sdet3ictpqs*b0fqswz*(-1d0/2/ctw**2*vpamo*vpabt/us*mtp-1
     & d0/2/ctw**2*vpamn*vpatp/us*mtp)
     & +propiwqs*sdet3ictpqs*b0fqswc*(-2d0/3/us*mtp+2d0/3*ctw**2/us*mtp)
     & +propiwqs*sdet3ictpts*c0ctptscwc*(1d0/2/ctw**2*vpamo*vpabt/us*mw*
     & *2*mtp+2d0/3/us*mw**2*mtp-2d0/3*ctw**2/us*mw**2*mtp)
     & +propiwqs*sdet3ictpts*c0ctptscztp*(1d0/2/ctw**4*vpamn*vpatp/us*mw
     & **2*mtp)
     & +propiwqs*sdet3ictpts*b0ftpwc*(1d0/2/ctw**2*vpamo*vpabt/us*mtp+2d
     & 0/3/us*mtp-2d0/3*ctw**2/us*mtp)
     & +propiwqs*sdet3ictpts*b0ftpztp*(1d0/2/ctw**2*vpamn*vpatp/us*mtp)
     & +propiwqs*sdet3ictpts*b0ftstpc*(-1d0/2/ctw**2*vpamn*vpatp/us*mtp)
     & +propiwqs*sdet3ictpts*b0ftscc*(-1d0/2/ctw**2*vpamo*vpabt/us*mtp-2
     & d0/3/us*mtp+2d0/3*ctw**2/us*mtp)
     & +propiwqs*d0tpcccqstswczc*(1d0/4/ctw**6*vpamo*vpabt/ts/us**2*mw**
     & 4*mtp**3+1d0/4/ctw**6*vpamo*vpabt/us**2*mw**4*mtp-1d0/4/ctw**4*vp
     & amo*vpabt/qs/us*mw**4*mtp-1d0/4/ctw**4*vpamo*vpabt/qs*mw**2*mtp-1
     & d0/2/ctw**4*vpamo*vpabt/us**2*mw**2*mtp**3+1d0/2/ctw**4*vpamo*vpa
     & bt/us**2*mw**4*mtp-1d0/2/ctw**4*vpamo*vpabt*ts/us**2*mw**2*mtp+1d
     & 0/4/ctw**2*vpamo*vpabt/qs/us**2*mw**4*mtp**3+1d0/4/ctw**2*vpamo*v
     & pabt/qs/us*mw**2*mtp**3+1d0/4/ctw**2*vpamo*vpabt/qs/us*mw**4*mtp+
     & 1d0/4/ctw**2*vpamo*vpabt/qs*mw**2*mtp+1d0/4/ctw**2*vpamo*vpabt/us
     & **2*mw**4*mtp+1d0/4/ctw**2*vpamo*vpabt/us*mw**2*mtp+1d0/4/ctw**2*
     & vpamo*vpabt*ts/us**2*mtp**3-1d0/2/ctw**2*vpamo*vpabt*ts/us**2*mw*
     & *2*mtp+1d0/4/ctw**2*vpamo*vpabt*ts**2/us**2*mtp)
     & +propiwqs*d0tpcccqstsztpwc*(1d0/4/ctw**6*vpamn*vpatp/qs/us**2*mw*
     & *4*mtp**3+1d0/4/ctw**6*vpamn*vpatp/qs/us*mw**4*mtp+1d0/4/ctw**6*v
     & pamn*vpatp/us**2*mw**4*mtp-1d0/4/ctw**4*vpamn*vmatp/qs/us*mw**2*m
     & tp**3-1d0/4/ctw**4*vpamn*vmatp/qs*mw**2*mtp-1d0/4/ctw**4*vpamn*vm
     & atp/us*mw**2*mtp+1d0/4/ctw**4*vpamn*vpatp/qs/us*mw**2*mtp**3-1d0/
     & 4/ctw**4*vpamn*vpatp/qs/us*mw**4*mtp+1d0/4/ctw**4*vpamn*vpatp/qs*
     & mw**2*mtp-1d0/2/ctw**4*vpamn*vpatp/us**2*mw**2*mtp**3+1d0/2/ctw**
     & 4*vpamn*vpatp/us**2*mw**4*mtp+1d0/4/ctw**4*vpamn*vpatp/us*mw**2*m
     & tp-1d0/2/ctw**4*vpamn*vpatp*ts/us**2*mw**2*mtp+1d0/4/ctw**2*vpamn
     & *vmatp/qs*mw**2*mtp+1d0/4/ctw**2*vpamn*vmatp/us*mtp**3-1d0/4/ctw*
     & *2*vpamn*vmatp/us*mw**2*mtp+1d0/4/ctw**2*vpamn*vmatp*ts/us*mtp-1d
     & 0/4/ctw**2*vpamn*vpatp/qs*mw**2*mtp+1d0/4/ctw**2*vpamn*vpatp/ts/u
     & s**2*mtp**7-1d0/2/ctw**2*vpamn*vpatp/ts/us**2*mw**2*mtp**5+1d0/4/
     & ctw**2*vpamn*vpatp/ts/us**2*mw**4*mtp**3+1d0/4/ctw**2*vpamn*vpatp
     & /ts/us*mtp**5-1d0/4/ctw**2*vpamn*vpatp/ts/us*mw**2*mtp**3+3d0/4/c
     & tw**2*vpamn*vpatp/us**2*mtp**5-1d0/ctw**2*vpamn*vpatp/us**2*mw**2
     & *mtp**3+1d0/4/ctw**2*vpamn*vpatp/us**2*mw**4*mtp+1d0/4/ctw**2*vpa
     & mn*vpatp/us*mtp**3+3d0/4/ctw**2*vpamn*vpatp*ts/us**2*mtp**3-1d0/2
     & /ctw**2*vpamn*vpatp*ts/us**2*mw**2*mtp+1d0/4/ctw**2*vpamn*vpatp*t
     & s**2/us**2*mtp)
     & +propiwqs*d0tpcccqsusztpwc*(-1d0/4/ctw**4*vpamo*vmatp/qs*mw**2*mt
     & p+1d0/4/ctw**4*vpamo*vmatp/ts*mw**2*mtp+1d0/4/ctw**2*vpamo*vmatp/
     & qs/us*mw**2*mtp**3+1d0/4/ctw**2*vpamo*vmatp/qs*mw**2*mtp-1d0/4/ct
     & w**2*vpamo*vmatp/ts/us*mtp**5+1d0/4/ctw**2*vpamo*vmatp/ts/us*mw**
     & 2*mtp**3-1d0/4/ctw**2*vpamo*vmatp/ts*mtp**3+1d0/4/ctw**2*vpamo*vm
     & atp/ts*mw**2*mtp+1d0/4/ctw**2*vpamo*vmatp*mtp+1d0/4/ctw**2*vpamo*
     & vmatp*qs/ts*mtp)
     & +propiwqs*c0ctpqswtpz*(1d0/4/ctw**4*vpamn*vpatp/qs/us**2*mw**2*mt
     & p**3+1d0/4/ctw**4*vpamn*vpatp/us**2*mw**2*mtp+1d0/4/ctw**2*vpamo*
     & vmatp/qs/us*mtp**3+1d0/4/ctw**2*vpamo*vmatp/ts*mtp-1d0/4/ctw**2*v
     & pamn*vmatp/qs/us*mtp**3-1d0/4/ctw**2*vpamn*vmatp/us*mtp+1d0/4/ctw
     & **2*vpamn*vpatp/qs/us*mtp**3+1d0/4/ctw**2*vpamn*vpatp/ts/us*mtp**
     & 3-1d0/4/ctw**2*vpamn*vpatp/ts/us*mw**2*mtp-1d0/4/ctw**2*vpamn*vpa
     & tp/us**2*mtp**3+1d0/4/ctw**2*vpamn*vpatp/us**2*mw**2*mtp-1d0/4/ct
     & w**2*vpamn*vpatp*ts/us**2*mtp)
     & +propiwqs*c0ctpqszcw*(-1d0/4/ctw**4*vpamo*vpabt/ts/us*mw**2*mtp+1
     & d0/4/ctw**4*vpamo*vpabt/us**2*mw**2*mtp+1d0/4/ctw**2*vpamo*vpabt/
     & qs/us**2*mw**2*mtp**3+1d0/4/ctw**2*vpamo*vpabt/qs/us*mtp**3+1d0/4
     & /ctw**2*vpamo*vpabt/us**2*mw**2*mtp-1d0/4/ctw**2*vpamo*vpabt*ts/u
     & s**2*mtp)
     & +propiwqs*c0ctptscwc*(-1d0/4/ctw**4*vpamo*vpabt/ts/us**2*mw**2*mt
     & p**3-1d0/4/ctw**4*vpamo*vpabt/us**2*mw**2*mtp+1d0/4/ctw**2*vpamo*
     & vpabt/qs/us*mw**2*mtp+1d0/4/ctw**2*vpamo*vpabt/qs*mtp+1d0/4/ctw**
     & 2*vpamo*vpabt/us**2*mtp**3-1d0/4/ctw**2*vpamo*vpabt/us**2*mw**2*m
     & tp-1d0/4/ctw**2*vpamo*vpabt/us*mtp+1d0/4/ctw**2*vpamo*vpabt*ts/us
     & **2*mtp+1d0/3/qs/us*mw**2*mtp+1d0/3/qs*mtp+1d0/3/us**2*mtp**3-1d0
     & /3/us**2*mw**2*mtp-1d0/3/us*mtp+1d0/3*ts/us**2*mtp-1d0/3*ctw**2/q
     & s/us*mw**2*mtp-1d0/3*ctw**2/qs*mtp-1d0/3*ctw**2/us**2*mtp**3+1d0/
     & 3*ctw**2/us**2*mw**2*mtp+1d0/3*ctw**2/us*mtp-1d0/3*ctw**2*ts/us**
     & 2*mtp)
     & +propiwqs*c0ctptscztp*(1d0/4/ctw**4*vpamn*vpatp/qs/us*mw**2*mtp-1
     & d0/4/ctw**4*vpamn*vpatp/us**2*mw**2*mtp-1d0/4/ctw**2*vpamn*vmatp/
     & qs*mtp+1d0/4/ctw**2*vpamn*vmatp/us*mtp+1d0/4/ctw**2*vpamn*vpatp/q
     & s*mtp+1d0/4/ctw**2*vpamn*vpatp/ts/us**2*mtp**5-1d0/4/ctw**2*vpamn
     & *vpatp/ts/us**2*mw**2*mtp**3+1d0/2/ctw**2*vpamn*vpatp/us**2*mtp**
     & 3-1d0/4/ctw**2*vpamn*vpatp/us**2*mw**2*mtp-1d0/4/ctw**2*vpamn*vpa
     & tp/us*mtp+1d0/4/ctw**2*vpamn*vpatp*ts/us**2*mtp)
     & +propiwqs*c0ctpuscztp*(-1d0/4/ctw**2*vpamo*vmatp/qs/us*mtp**3-1d0
     & /4/ctw**2*vpamo*vmatp/qs*mtp-1d0/4/ctw**2*vpamo*vmatp/ts/us*mtp**
     & 3-1d0/4/ctw**2*vpamo*vmatp/ts*mtp)
     & +propiwqs*c0ccqswcz*(1d0/4/ctw**4*vpamo*vpabt/ts/us**2*mw**2*mtp*
     & *3+1d0/4/ctw**4*vpamo*vpabt/ts/us*mw**2*mtp+1d0/4/ctw**4*vpamo*vp
     & abt/us**2*mw**2*mtp+1d0/4/ctw**4*vpamn*vpatp/us**2*mw**2*mtp-1d0/
     & 4/ctw**2*vpamo*vpabt/us**2*mtp**3+1d0/4/ctw**2*vpamo*vpabt/us**2*
     & mw**2*mtp-1d0/4/ctw**2*vpamo*vpabt*ts/us**2*mtp+1d0/4/ctw**2*vpam
     & o*vmatp/ts/us*mtp**3+1d0/4/ctw**2*vpamo*vmatp/ts*mtp-1d0/4/ctw**2
     & *vpamn*vmatp/us*mtp-1d0/4/ctw**2*vpamn*vpatp/ts/us**2*mtp**5+1d0/
     & 4/ctw**2*vpamn*vpatp/ts/us**2*mw**2*mtp**3-1d0/4/ctw**2*vpamn*vpa
     & tp/ts/us*mtp**3+1d0/4/ctw**2*vpamn*vpatp/ts/us*mw**2*mtp-1d0/2/ct
     & w**2*vpamn*vpatp/us**2*mtp**3+1d0/4/ctw**2*vpamn*vpatp/us**2*mw**
     & 2*mtp-1d0/4/ctw**2*vpamn*vpatp*ts/us**2*mtp)
     & +propiwqs*c0cctscwtp*(-1d0/4/ctw**4*vpamn*vpatp/qs/us**2*mw**2*mt
     & p**3-1d0/4/ctw**4*vpamn*vpatp/qs/us*mw**2*mtp-1d0/4/ctw**4*vpamn*
     & vpatp/us**2*mw**2*mtp+1d0/4/ctw**2*vpamn*vmatp/qs/us*mtp**3+1d0/4
     & /ctw**2*vpamn*vmatp/qs*mtp+1d0/4/ctw**2*vpamn*vmatp/us*mtp-1d0/4/
     & ctw**2*vpamn*vpatp/qs/us*mtp**3-1d0/4/ctw**2*vpamn*vpatp/qs*mtp+1
     & d0/4/ctw**2*vpamn*vpatp/us**2*mtp**3-1d0/4/ctw**2*vpamn*vpatp/us*
     & *2*mw**2*mtp-1d0/4/ctw**2*vpamn*vpatp/us*mtp+1d0/4/ctw**2*vpamn*v
     & patp*ts/us**2*mtp)
     & +propiwqs*c0cctsczc*(-1d0/4/ctw**4*vpamo*vpabt/us**2*mw**2*mtp-1d
     & 0/4/ctw**2*vpamo*vpabt/qs/us**2*mw**2*mtp**3-1d0/4/ctw**2*vpamo*v
     & pabt/qs/us*mtp**3-1d0/4/ctw**2*vpamo*vpabt/qs/us*mw**2*mtp-1d0/4/
     & ctw**2*vpamo*vpabt/qs*mtp-1d0/4/ctw**2*vpamo*vpabt/us**2*mw**2*mt
     & p-1d0/4/ctw**2*vpamo*vpabt/us*mtp+1d0/4/ctw**2*vpamo*vpabt*ts/us*
     & *2*mtp)
     & +propiwqs*c0ccuscwtp*(1d0/4/ctw**2*vpamo*vmatp/qs*mtp-1d0/4/ctw**
     & 2*vpamo*vmatp/ts*mtp-2d0/3/qs*mtp+2d0/3/ts*mtp+2d0/3*ctw**2/qs*mt
     & p-2d0/3*ctw**2/ts*mtp)
     & +sdet3ictpqs**3*c0ctpqswtpz*(3d0/4*vmatp/mw**2*mtp**9-3d0/2*vmatp
     & *mtp**7+3d0/4*vmatp*mw**2*mtp**5-3d0/4*vpatp/mw**2*mtp**9-3d0/2*v
     & patp*mtp**7+21d0/4*vpatp*mw**2*mtp**5-3*vpatp*mw**4*mtp**3)
     & +sdet3ictpqs**3*c0ctpqswtph*(-3d0/4/mw**2*mtp**9+3d0/2*mtp**7-3d0
     & /4*mw**2*mtp**5)
     & +sdet3ictpqs**3*c0ctpqswtpc*(-4*mtp**7+8*mw**2*mtp**5-4*mw**4*mtp
     & **3+4*ctw**2*mtp**7-8*ctw**2*mw**2*mtp**5+4*ctw**2*mw**4*mtp**3)
     & +sdet3ictpqs**3*c0ctpqszcw*(3/ctw**4*vpabt*mw**4*mtp**3)
     & +sdet3ictpqs**3*c0ctpqscztp*(3d0/2/ctw**6*vpatp*vpabt*mw**4*mtp**
     & 3)
     & +sdet3ictpqs**3*a0ftp*(4*mtp**5-4*mw**2*mtp**3-4*ctw**2*mtp**5+4*
     & ctw**2*mw**2*mtp**3)
     & +sdet3ictpqs**3*b0ftpwc*(-3/ctw**2*vpabt*mw**2*mtp**3)
     & +sdet3ictpqs**3*b0ftpztp*(3d0/2/ctw**4*vpatp*vpabt*mw**2*mtp**3+3
     & d0/4*vmatp/mw**2*mtp**7-3d0/4*vmatp*mtp**5-3d0/4*vpatp/mw**2*mtp*
     & *7-9d0/4*vpatp*mtp**5+3*vpatp*mw**2*mtp**3)
     & +sdet3ictpqs**3*b0ftphtp*(-3d0/4/mw**2*mtp**7+3d0/4*mtp**5)
     & +sdet3ictpqs**3*b0fqswz*(3/ctw**2*vpabt*mw**2*mtp**3-3d0/4*vmatp/
     & mw**2*mtp**7+3d0/4*vmatp*mtp**5+3d0/4*vpatp/mw**2*mtp**7+9d0/4*vp
     & atp*mtp**5-3*vpatp*mw**2*mtp**3)
     & +sdet3ictpqs**3*b0fqswh*(3d0/4/mw**2*mtp**7-3d0/4*mtp**5)
     & +sdet3ictpqs**3*b0fqswc*(4*mtp**5-4*mw**2*mtp**3-4*ctw**2*mtp**5+
     & 4*ctw**2*mw**2*mtp**3)
     & +sdet3ictpqs**3*b0fqstpc*(-3d0/2/ctw**4*vpatp*vpabt*mw**2*mtp**3)
     & +sdet3ictpqs**3*(-4*mtp**5+4*mw**2*mtp**3+4*ctw**2*mtp**5-4*ctw**
     & 2*mw**2*mtp**3)
     & +sdet3ictpqs**2*c0ctpqswtpz*(1d0/2/ctw**2*vmatp*mtp**5-1d0/2/ctw*
     & *2*vmatp*mw**2*mtp**3-1d0/2/ctw**2*vpatp*mtp**5-3d0/2/ctw**2*vpat
     & p*mw**2*mtp**3+2/ctw**2*vpatp*mw**4*mtp-7d0/4*vmatp/mw**2*mtp**7+
     & 5*vmatp*mtp**5-13d0/4*vmatp*mw**2*mtp**3+7d0/4*vpatp/mw**2*mtp**7
     & +2*vpatp*mtp**5-19d0/4*vpatp*mw**2*mtp**3+vpatp*mw**4*mtp)
     & +sdet3ictpqs**2*c0ctpqswtph*(3d0/4/mw**2*mtp**7-1d0/2/mw**2*mh**2
     & *mtp**5+1d0/2*mh**2*mtp**3-3d0/4*mw**2*mtp**3)
     & +sdet3ictpqs**2*c0ctpqswtpc*(28d0/3*mtp**5-32d0/3*mw**2*mtp**3+4d
     & 0/3*mw**4*mtp-28d0/3*ctw**2*mtp**5+32d0/3*ctw**2*mw**2*mtp**3-4d0
     & /3*ctw**2*mw**4*mtp)
     & +sdet3ictpqs**2*c0ctpqszcw*(-1d0/ctw**4*vpabt*mw**2*mtp**3-1d0/ct
     & w**4*vpabt*mw**4*mtp+2/ctw**2*vpabt*mw**2*mtp**3-2/ctw**2*vpabt*m
     & w**4*mtp)
     & +sdet3ictpqs**2*c0ctpqscztp*(-3d0/2/ctw**6*vpatp*vpabt*mw**4*mtp+
     & 1d0/ctw**4*vmatp*vpabt*mw**2*mtp**3-1d0/ctw**4*vpatp*vpabt*mw**2*
     & mtp**3)
     & +sdet3ictpqs**2*a0fw*(3d0/8*mtp**3+5d0/12*mw**2*mtp-3d0/8*vmatp*m
     & tp**3-5d0/4*vmatp*mw**2*mtp+3d0/8*vpatp*mtp**3+7d0/4*vpatp*mw**2*
     & mtp-2d0/3*ctw**2*mw**2*mtp-19d0/12*invftpw*mtp**3+19d0/12*invftpw
     & *mw**2*mtp-5d0/4*invftpw*vmatp*mtp**3+5d0/4*invftpw*vmatp*mw**2*m
     & tp+1d0/4*invftpw*vpatp*mtp**3-1d0/4*invftpw*vpatp*mw**2*mtp+4d0/3
     & *invftpw*ctw**2*mtp**3-4d0/3*invftpw*ctw**2*mw**2*mtp)
     & +sdet3ictpqs**2*a0fz*(3d0/4/ctw**4*vpatp*vpabt*mw**2*mtp-3d0/2/ct
     & w**2*vpabt*mw**2*mtp)
     & +sdet3ictpqs**2*a0ftp*(-3d0/8/mw**2*mtp**5-22d0/3*mtp**3+35d0/12*
     & mw**2*mtp+3d0/8*vmatp/mw**2*mtp**5+5d0/4*vmatp*mw**2*mtp-3d0/8*vp
     & atp/mw**2*mtp**5-3d0/2*vpatp*mtp**3-1d0/4*vpatp*mw**2*mtp+22d0/3*
     & ctw**2*mtp**3-8d0/3*ctw**2*mw**2*mtp+19d0/12*invftpw*mtp**3-19d0/
     & 12*invftpw*mw**2*mtp+5d0/4*invftpw*vmatp*mtp**3-5d0/4*invftpw*vma
     & tp*mw**2*mtp-1d0/4*invftpw*vpatp*mtp**3+1d0/4*invftpw*vpatp*mw**2
     & *mtp-4d0/3*invftpw*ctw**2*mtp**3+4d0/3*invftpw*ctw**2*mw**2*mtp)
     & +sdet3ictpqs**2*b0ftpwc*(1d0/ctw**2*vpabt*mtp**3+1d0/ctw**2*vpabt
     & *mw**2*mtp+1d0/3*mtp**3-1d0/3*mw**2*mtp-1d0/2*vpabt*mtp**3+1d0/2*
     & vpabt*mw**2*mtp-1d0/3*ctw**2*mtp**3+1d0/3*ctw**2*mw**2*mtp)
     & +sdet3ictpqs**2*b0ftpztp*(-3d0/4/ctw**4*vpatp*vpabt*mw**2*mtp+1d0
     & /8/ctw**2*vmatp*mtp**3+1d0/ctw**2*vmatp*vpabt*mtp**3-1d0/8/ctw**2
     & *vpatp*mtp**3-1d0/2/ctw**2*vpatp*mw**2*mtp-1d0/ctw**2*vpatp*vpabt
     & *mtp**3-vmatp/mw**2*mtp**5+13d0/4*vmatp*mtp**3+vpatp/mw**2*mtp**5
     & +3d0/4*vpatp*mtp**3-vpatp*mw**2*mtp)
     & +sdet3ictpqs**2*b0ftphtp*(-1d0/8/mw**2*mh**2*mtp**3+3d0/4*mtp**3)
     & +sdet3ictpqs**2*b0fqswz*(-1d0/ctw**2*vpabt*mtp**3-5d0/2/ctw**2*vp
     & abt*mw**2*mtp-1d0/8/ctw**2*vmatp*mtp**3+1d0/8/ctw**2*vpatp*mtp**3
     & +1d0/2/ctw**2*vpatp*mw**2*mtp+1d0/2*vpabt*mtp**3-1d0/2*vpabt*mw**
     & 2*mtp+11d0/8*vmatp/mw**2*mtp**5-29d0/8*vmatp*mtp**3-11d0/8*vpatp/
     & mw**2*mtp**5-15d0/8*vpatp*mtp**3+5d0/2*vpatp*mw**2*mtp)
     & +sdet3ictpqs**2*b0fqswh*(-3d0/8/mw**2*mtp**5+1d0/8/mw**2*mh**2*mt
     & p**3-3d0/8*mtp**3)
     & +sdet3ictpqs**2*b0fqswc*(-23d0/3*mtp**3+11d0/3*mw**2*mtp+23d0/3*c
     & tw**2*mtp**3-11d0/3*ctw**2*mw**2*mtp)
     & +sdet3ictpqs**2*b0fqstpc*(3d0/2/ctw**4*vpatp*vpabt*mw**2*mtp-1d0/
     & ctw**2*vmatp*vpabt*mtp**3+1d0/ctw**2*vpatp*vpabt*mtp**3)
     & +sdet3ictpqs**2*(16d0/3*mtp**3-4d0/3*mw**2*mtp-16d0/3*ctw**2*mtp*
     & *3+4d0/3*ctw**2*mw**2*mtp)
     & +sdet3ictpqs*c0ctpqswtpz*(-3d0/4/ctw**2*vmatp*mtp**3+2/ctw**2*vma
     & tp*mw**2*mtp+1d0/4/ctw**2*vpatp*mtp**3-1d0/2/ctw**2*vpatp*mw**2*m
     & tp+5d0/4*vmatp/mw**2*mtp**5-9d0/2*vmatp*mtp**3+vmatp*mw**2*mtp-5d
     & 0/4*vpatp/mw**2*mtp**5+1d0/2*vpatp*mtp**3)
     & +sdet3ictpqs*c0ctpqswtph*(1d0/4/mw**2*mtp**5-1d0/4/mw**2*mh**2*mt
     & p**3-mtp**3+1d0/2*mh**2*mtp)
     & +sdet3ictpqs*c0ctpqswtpc*(-16d0/3*mtp**3+4d0/3*mw**2*mtp+16d0/3*c
     & tw**2*mtp**3-4d0/3*ctw**2*mw**2*mtp)
     & +sdet3ictpqs*c0ctpqszcw*(-1d0/2/ctw**2*vpabt*mtp**3+1d0/2/ctw**2*
     & vpabt*mw**2*mtp)
     & +sdet3ictpqs*c0ctpqscztp*(-1d0/ctw**4*vmatp*vpabt*mw**2*mtp+2/ctw
     & **4*vpatp*vpabt*mw**2*mtp)
     & +sdet3ictpqs*a0fw*(1d0/4*mtp-1d0/3*mw**2/mtp+1d0/2*vpabt*mw**2/mt
     & p+1d0/4*vmatp*mtp-1d0/4*vpatp*mtp+1d0/3*ctw**2*mw**2/mtp+19d0/12*
     & invftpw*mtp+5d0/4*invftpw*vmatp*mtp-1d0/4*invftpw*vpatp*mtp-4d0/3
     & *invftpw*ctw**2*mtp)
     & +sdet3ictpqs*a0fz*(-1d0/4/ctw**4*vpatp*vpabt*mw**2/mtp+1d0/2/ctw*
     & *2*vpabt*mtp+1d0/8/ctw**2*vmatp*mtp+1d0/2/ctw**2*vmatp*vpabt*mtp-
     & 1d0/8/ctw**2*vpatp*mtp-1d0/2/ctw**2*vpatp*mw**2/mtp-1d0/2/ctw**2*
     & vpatp*vpabt*mtp)
     & +sdet3ictpqs*a0fh*(-1d0/8/mw**2*mh**2*mtp)
     & +sdet3ictpqs*a0ftp*(1d0/4/ctw**2*vpatp*vpabt*mtp-1d0/8/mw**2*mtp*
     & *3+89d0/36*mtp-3d0/8*vmatp/mw**2*mtp**3+5d0/4*vmatp*mtp+3d0/8*vpa
     & tp/mw**2*mtp**3+1d0/4*vpatp*mtp-20d0/9*ctw**2*mtp-19d0/12*invftpw
     & *mtp-5d0/4*invftpw*vmatp*mtp+1d0/4*invftpw*vpatp*mtp+4d0/3*invftp
     & w*ctw**2*mtp)
     & +sdet3ictpqs*b0ftpwc*(1d0/3*mtp-1d0/3*mw**2/mtp-1d0/2*vpabt*mtp+1
     & d0/2*vpabt*mw**2/mtp-1d0/3*ctw**2*mtp+1d0/3*ctw**2*mw**2/mtp)
     & +sdet3ictpqs*b0ftpztp*(-1d0/4/ctw**4*vpatp*vpabt*mw**2/mtp-3d0/8/
     & ctw**2*vmatp*mtp-1d0/2/ctw**2*vmatp*vpabt*mtp-1d0/8/ctw**2*vpatp*
     & mtp-1d0/2/ctw**2*vpatp*mw**2/mtp+1d0/ctw**2*vpatp*vpabt*mtp+1d0/4
     & *vmatp/mw**2*mtp**3-vmatp*mtp-1d0/4*vpatp/mw**2*mtp**3+vpatp*mtp)
     & 
     & +sdet3ictpqs*b0ftphtp*(1d0/4/mw**2*mtp**3-1d0/8/mw**2*mh**2*mtp)
     & +sdet3ictpqs*b0fqswz*(1d0/2/ctw**2*vpabt*mtp+1d0/2/ctw**2*vmatp*m
     & tp+1d0/2*vpabt*mtp-5d0/8*vmatp/mw**2*mtp**3+5d0/2*vmatp*mtp+5d0/8
     & *vpatp/mw**2*mtp**3-vpatp*mtp)
     & +sdet3ictpqs*b0fqswh*(-3d0/8/mw**2*mtp**3+1d0/2*mtp)
     & +sdet3ictpqs*b0fqswc*(5d0/3*mtp-5d0/3*ctw**2*mtp)
     & +sdet3ictpqs*b0fqstpc*(1d0/ctw**2*vmatp*vpabt*mtp-5d0/4/ctw**2*vp
     & atp*vpabt*mtp+2d0/9*mtp-2d0/9*ctw**2*mtp)
     & +sdet3ictpqs*(-1d0/4/ctw**2*vpatp*vpabt*mtp+1d0/8/mw**2*mtp**3+7d
     & 0/9*mtp-1d0/2*vpabt*mtp-1d0/8*vmatp/mw**2*mtp**3+1d0/8*vpatp/mw**
     & 2*mtp**3+1d0/2*vpatp*mtp-7d0/9*ctw**2*mtp)
     & +jawsubsubqstsctpw*(1d0/3/qs/us**2*mw**4*mtp**3+1d0/3/qs/us*mw**2
     & *mtp**3+1d0/3/qs/us*mw**4*mtp+1d0/3/qs*mw**2*mtp+1d0/3/us**2*mw**
     & 4*mtp+1d0/3/us*mw**2*mtp+1d0/3*ts/us**2*mtp**3-2d0/3*ts/us**2*mw*
     & *2*mtp+1d0/3*ts**2/us**2*mtp-1d0/3*ctw**2/qs/us**2*mw**4*mtp**3-1
     & d0/3*ctw**2/qs/us*mw**2*mtp**3-1d0/3*ctw**2/qs/us*mw**4*mtp-1d0/3
     & *ctw**2/qs*mw**2*mtp-1d0/3*ctw**2/us**2*mw**4*mtp-1d0/3*ctw**2/us
     & *mw**2*mtp-1d0/3*ctw**2*ts/us**2*mtp**3+2d0/3*ctw**2*ts/us**2*mw*
     & *2*mtp-1d0/3*ctw**2*ts**2/us**2*mtp)
     & +jawsubsubqsustpcw*(-2d0/3/qs/us*mw**2*mtp**3-2d0/3/qs*mw**2*mtp+
     & 2d0/3/ts/us*mtp**5-2d0/3/ts/us*mw**2*mtp**3+2d0/3/ts*mtp**3-2d0/3
     & /ts*mw**2*mtp-2d0/3*mtp-2d0/3*qs/ts*mtp+2d0/3*ctw**2/qs/us*mw**2*
     & mtp**3+2d0/3*ctw**2/qs*mw**2*mtp-2d0/3*ctw**2/ts/us*mtp**5+2d0/3*
     & ctw**2/ts/us*mw**2*mtp**3-2d0/3*ctw**2/ts*mtp**3+2d0/3*ctw**2/ts*
     & mw**2*mtp+2d0/3*ctw**2*mtp+2d0/3*ctw**2*qs/ts*mtp)
     & +c0ctpqswtpz*(-1d0/4*vmatp/mw**2*mtp**3+1d0/4*vpatp/mw**2*mtp**3)
     & +c0ctpqswtph*(-1d0/4/mw**2*mtp**3)
     & +c0ctpqswtpc*(-2d0/3/qs/us*mw**2*mtp**3-2d0/3/ts*mw**2*mtp-2d0/3/
     & us*mtp**3-2d0/3*qs/ts*mtp+2d0/3*ctw**2/qs/us*mw**2*mtp**3+2d0/3*c
     & tw**2/ts*mw**2*mtp+2d0/3*ctw**2/us*mtp**3+2d0/3*ctw**2*qs/ts*mtp)
     & 
     & +c0ctpqscztp*(1d0/2/ctw**2*vmatp*vpabt*mtp-1d0/2/ctw**2*vpatp*vpa
     & bt*mtp)

      ff_ew_rdl=
     & 0

      ffarray(1,1) = ff_ew_ll
      ffarray(1,2) = ff_ew_rl
      ffarray(1,3) = ff_ew_ldl
      ffarray(1,4) = ff_ew_rdl

      return
      end
