************************************************************************
* sanc_cc_v1.50 package.
************************************************************************
* File (cc_ha_1413_43.f) is created on Thu Jan 19 01:32:34 MSK 2012.
************************************************************************
* This is the FORTRAN module (cc_ha_1413_43) to calculate differential
* hard photon Bremsstrahlung for the anti-dn + up -> H   + W^+ process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2012.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ha_1413_43 (s,spr,ph3,costh3,costh5,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 sq,sqspr,qw
      real*8 p1p2,p1p3,p1p4,p1p5,p2p3,p2p4,p2p5,p3p4,p3p5,p4p5
      real*8 ph3,cosph3,sinph3,costh3,sinth3,costh5,sinth5
      real*8 sqrtlsprwh,isqrtlsprwh,sqrtlssprc,isqrtlssprc,sqrtlsdnup,i
     & sqrtlsdnup
      real*8 iz1dn,iz2up,iz3w
      complex*16 idenw34p,denw34p,denw34pc,idenw12p,denw12p,denw12pc

      qw = 1d0

      sq = dsqrt(s)
      sqspr = dsqrt(spr)

      cosph3 = dcos(ph3)
      sinph3 = dsin(ph3)
      sinth3 = dsqrt(1d0-costh3**2)
      sinth5 = dsqrt(1d0-costh5**2)

      sqrtlsprwh = sqrt(spr**2-2d0*spr*(rwm2+rhm2)+(rwm2-rhm2)**2)
      isqrtlsprwh = 1d0/sqrtlsprwh
      sqrtlssprc = dabs(s-spr)
      isqrtlssprc = 1d0/sqrtlssprc
      sqrtlsdnup = sqrt(s**2-2d0*s*(rdnm2+rupm2)+(rdnm2-rupm2)**2)
      isqrtlsdnup = 1d0/sqrtlsdnup

      p1p2=
     & -1d0/2*s

      p1p3=
     & +sinph3*sinth3*sinth5*sqrtlsprwh*(-1d0/4/sq/sqspr*s)
     & +costh3*costh5*sqrtlsprwh*(1d0/8+1d0/8*s/spr)
     & +costh3*sqrtlsprwh*(-1d0/8+1d0/8*s/spr)
     & +costh5*(1d0/8*spr-1d0/8*s-1d0/8*mh**2+1d0/8*mh**2*s/spr+1d0/8*mw
     & **2-1d0/8*mw**2*s/spr)
     & -1d0/8*spr-1d0/8*s+1d0/8*mh**2+1d0/8*mh**2*s/spr-1d0/8*mw**2-1d0/
     & 8*mw**2*s/spr

      p1p4=
     & +sinph3*sinth3*sinth5*sqrtlsprwh*(1d0/4/sq/sqspr*s)
     & +costh3*costh5*sqrtlsprwh*(-1d0/8-1d0/8*s/spr)
     & +costh3*sqrtlsprwh*(1d0/8-1d0/8*s/spr)
     & +costh5*(1d0/8*spr-1d0/8*s+1d0/8*mh**2-1d0/8*mh**2*s/spr-1d0/8*mw
     & **2+1d0/8*mw**2*s/spr)
     & -1d0/8*spr-1d0/8*s-1d0/8*mh**2-1d0/8*mh**2*s/spr+1d0/8*mw**2+1d0/
     & 8*mw**2*s/spr

      p1p5=
     & +costh5*sqrtlssprc*(1d0/4)
     & +sqrtlssprc*(-1d0/4)

      p2p3=
     & +sinph3*sinth3*sinth5*sqrtlsprwh*(1d0/4/sq/sqspr*s)
     & +costh3*costh5*sqrtlsprwh*(-1d0/8-1d0/8*s/spr)
     & +costh3*sqrtlsprwh*(-1d0/8+1d0/8*s/spr)
     & +costh5*(-1d0/8*spr+1d0/8*s+1d0/8*mh**2-1d0/8*mh**2*s/spr-1d0/8*m
     & w**2+1d0/8*mw**2*s/spr)
     & -1d0/8*spr-1d0/8*s+1d0/8*mh**2+1d0/8*mh**2*s/spr-1d0/8*mw**2-1d0/
     & 8*mw**2*s/spr

      p2p4=
     & +sinph3*sinth3*sinth5*sqrtlsprwh*(-1d0/4/sq/sqspr*s)
     & +costh3*costh5*sqrtlsprwh*(1d0/8+1d0/8*s/spr)
     & +costh3*sqrtlsprwh*(1d0/8-1d0/8*s/spr)
     & +costh5*(-1d0/8*spr+1d0/8*s-1d0/8*mh**2+1d0/8*mh**2*s/spr+1d0/8*m
     & w**2-1d0/8*mw**2*s/spr)
     & -1d0/8*spr-1d0/8*s-1d0/8*mh**2-1d0/8*mh**2*s/spr+1d0/8*mw**2+1d0/
     & 8*mw**2*s/spr

      p2p5=
     & +costh5*sqrtlssprc*(-1d0/4)
     & +sqrtlssprc*(-1d0/4)

      p3p4=
     & -1d0/2*spr+1d0/2*mh**2+1d0/2*mw**2

      p3p5=
     & +costh3*sqrtlssprc*sqrtlsprwh*(1d0/4/spr)
     & +sqrtlssprc*(-1d0/4+1d0/8*mh**2/spr-1d0/8*mw**2/spr)
     & -1d0/8*mh**2+1d0/8*mh**2*s/spr+1d0/8*mw**2-1d0/8*mw**2*s/spr

      p4p5=
     & +costh3*sqrtlssprc*sqrtlsprwh*(-1d0/4/spr)
     & +sqrtlssprc*(-1d0/4-1d0/8*mh**2/spr+1d0/8*mw**2/spr)
     & +1d0/8*mh**2-1d0/8*mh**2*s/spr-1d0/8*mw**2+1d0/8*mw**2*s/spr

      iz1dn=
     & +1d0/(mdn**2/s+1d0/4*sinth5**2*sqrtlsdnup**2/s**2)/(s-spr)*(1d0/2
     & +1d0/2*mdn**2/s-1d0/2*mup**2/s+1d0/2*costh5*sqrtlsdnup/s)

      iz2up=
     & +1d0/(mup**2/s+1d0/4*sinth5**2*sqrtlsdnup**2/s**2)/(s-spr)*(1d0/2
     & -1d0/2*mdn**2/s+1d0/2*mup**2/s-1d0/2*costh5*sqrtlsdnup/s)

      iz3w=
     & +1d0/(1d0/4-1d0/2*mh**2/spr+1d0/4*mh**4/spr**2+1d0/2*mw**2/spr-1d
     & 0/2*mw**2*mh**2/spr**2+1d0/4*mw**4/spr**2+1d0/4*sinth3**2*sqrtlsp
     & rwh**2/spr**2-1d0/4*sqrtlsprwh**2/spr**2)/(s-spr)*(1d0/2-1d0/2*mh
     & **2/spr+1d0/2*mw**2/spr+1d0/2*costh3*sqrtlsprwh/spr)

      idenw12p = (mw**2+2d0*p1p2)
      denw12p = 1d0/idenw12p
      denw12pc = dconjg(denw12p)
      idenw34p = (-mh**2+2d0*p3p4)
      denw34p = 1d0/idenw34p
      denw34pc = dconjg(denw34p)

      hard=
     & +iz1dn**2*theta_hard(s,spr,omega)*denw34p*denw34pc*sqrtlssprc*sqr
     & tlsprwh/pi**4*g**6*stw**2*qdn**2*mdn**2/s**2/spr*(1d0/6144*p1p2*m
     & w**2-1d0/3072*p1p3*p2p3+1d0/3072*p2p3*p3p5-1d0/6144*p2p5*mw**2)
     & +iz1dn*iz2up*theta_hard(s,spr,omega)*denw34p*denw34pc*sqrtlssprc*
     & sqrtlsprwh/pi**4*g**6*stw**2*qup*qdn/s**2/spr*(-1d0/1536*p1p2*p1p
     & 3*p2p3+1d0/3072*p1p2*p1p3*p3p5+1d0/3072*p1p2*p2p3*p3p5+1d0/3072*p
     & 1p2**2*mw**2)
     & +iz1dn*iz3w*theta_hard(s,spr,omega)*denw12p*denw34pc*sqrtlssprc*s
     & qrtlsprwh/pi**4*g**6*stw**2*qdn/s**2/spr*(-1d0/6144*p1p2*p1p3*mw*
     & *2+1d0/12288*p1p3*p2p5*mw**2+1d0/3072*p1p3**2*p2p3+1d0/6144*p1p3*
     & *2*p2p5)
     & +iz1dn*iz3w*theta_hard(s,spr,omega)*denw34p*denw12pc*sqrtlssprc*s
     & qrtlsprwh/pi**4*g**6*stw**2*qdn/s**2/spr*(-1d0/6144*p1p2*p1p3*mw*
     & *2+1d0/12288*p1p3*p2p5*mw**2+1d0/3072*p1p3**2*p2p3+1d0/6144*p1p3*
     & *2*p2p5)
     & +iz1dn*denw12p*denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*
     & stw**2*qdn/s**2/spr*(-1d0/3072*p1p2*p1p3*p2p3+1d0/6144*p1p2*p1p3*
     & p3p5+1d0/6144*p1p2*p2p3*p3p5-1d0/6144*p1p2*p2p5*mw**2+1d0/6144*p1
     & p2**2*mw**2+1d0/6144*p1p3*p2p3*p2p5-1d0/6144*p1p3**2*p2p5)
     & +iz1dn*denw12p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*q
     & dn/s**2/spr*(1d0/12288*p1p2*p1p3-1d0/24576*p1p2*mw**2+1d0/6144*p1
     & p3*p2p3)
     & +iz1dn*denw34p*denw12pc*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6
     & *stw**2*qdn/s**2/spr*(-1d0/3072*p1p2*p1p3*p2p3+1d0/6144*p1p2*p1p3
     & *p3p5+1d0/6144*p1p2*p2p3*p3p5-1d0/6144*p1p2*p2p5*mw**2+1d0/6144*p
     & 1p2**2*mw**2+1d0/6144*p1p3*p2p3*p2p5-1d0/6144*p1p3**2*p2p5)
     & +iz1dn*denw34p*denw12pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*q
     & dn/s**2/spr*(1d0/12288*p1p2*p1p3-1d0/24576*p1p2*mw**2+1d0/6144*p1
     & p3*p2p3)
     & +iz1dn*denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*q
     & dn/s**2/spr*(1d0/6144*p1p2*p1p3*p3p5/mw**2+1d0/6144*p1p2*p2p3*p3p
     & 5/mw**2-1d0/6144*p1p2*p3p5**2/mw**2-1d0/6144*p1p3*p2p3*p2p5/mw**2
     & +1d0/6144*p1p3*p2p5*p3p5/mw**2-1d0/6144*p1p3**2*p2p5/mw**2)
     & +iz1dn*denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*q
     & dn**2/s**2/spr*(1d0/6144*p1p2*p1p3*p3p5/mw**2+1d0/6144*p1p2*p2p3*
     & p3p5/mw**2-1d0/6144*p1p2*p3p5**2/mw**2-1d0/6144*p1p3*p2p3*p2p5/mw
     & **2+1d0/6144*p1p3*p2p5*p3p5/mw**2-1d0/6144*p1p3**2*p2p5/mw**2+1d0
     & /6144*p2p3*p3p5-1d0/12288*p2p5*mw**2)
     & +iz1dn*denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*q
     & up*qdn/s**2/spr*(-1d0/6144*p1p2*p1p3*p3p5/mw**2-1d0/6144*p1p2*p2p
     & 3*p3p5/mw**2+1d0/6144*p1p2*p3p5**2/mw**2+1d0/6144*p1p2*mw**2+1d0/
     & 6144*p1p3*p2p3*p2p5/mw**2-1d0/6144*p1p3*p2p3-1d0/6144*p1p3*p2p5*p
     & 3p5/mw**2+1d0/6144*p1p3**2*p2p5/mw**2+1d0/6144*p1p3**2)
     & +iz2up**2*theta_hard(s,spr,omega)*denw34p*denw34pc*sqrtlssprc*sqr
     & tlsprwh/pi**4*g**6*stw**2*qup**2*mup**2/s**2/spr*(1d0/6144*p1p2*m
     & w**2-1d0/3072*p1p3*p2p3+1d0/3072*p1p3*p3p5-1d0/6144*p1p5*mw**2)
     & +iz2up*iz3w*theta_hard(s,spr,omega)*denw12p*denw34pc*sqrtlssprc*s
     & qrtlsprwh/pi**4*g**6*stw**2*qup/s**2/spr*(1d0/6144*p1p2*p2p3*mw**
     & 2-1d0/3072*p1p3*p2p3**2-1d0/12288*p1p5*p2p3*mw**2-1d0/6144*p1p5*p
     & 2p3**2)
     & +iz2up*iz3w*theta_hard(s,spr,omega)*denw34p*denw12pc*sqrtlssprc*s
     & qrtlsprwh/pi**4*g**6*stw**2*qup/s**2/spr*(1d0/6144*p1p2*p2p3*mw**
     & 2-1d0/3072*p1p3*p2p3**2-1d0/12288*p1p5*p2p3*mw**2-1d0/6144*p1p5*p
     & 2p3**2)
     & +iz2up*denw12p*denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*
     & stw**2*qup/s**2/spr*(1d0/3072*p1p2*p1p3*p2p3-1d0/6144*p1p2*p1p3*p
     & 3p5+1d0/6144*p1p2*p1p5*mw**2-1d0/6144*p1p2*p2p3*p3p5-1d0/6144*p1p
     & 2**2*mw**2-1d0/6144*p1p3*p1p5*p2p3+1d0/6144*p1p5*p2p3**2)
     & +iz2up*denw12p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*q
     & up/s**2/spr*(-1d0/12288*p1p2*p2p3+1d0/24576*p1p2*mw**2-1d0/6144*p
     & 1p3*p2p3)
     & +iz2up*denw34p*denw12pc*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6
     & *stw**2*qup/s**2/spr*(1d0/3072*p1p2*p1p3*p2p3-1d0/6144*p1p2*p1p3*
     & p3p5+1d0/6144*p1p2*p1p5*mw**2-1d0/6144*p1p2*p2p3*p3p5-1d0/6144*p1
     & p2**2*mw**2-1d0/6144*p1p3*p1p5*p2p3+1d0/6144*p1p5*p2p3**2)
     & +iz2up*denw34p*denw12pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*q
     & up/s**2/spr*(-1d0/12288*p1p2*p2p3+1d0/24576*p1p2*mw**2-1d0/6144*p
     & 1p3*p2p3)
     & +iz2up*denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*q
     & up/s**2/spr*(-1d0/6144*p1p2*p1p3*p3p5/mw**2-1d0/6144*p1p2*p2p3*p3
     & p5/mw**2+1d0/6144*p1p2*p3p5**2/mw**2+1d0/6144*p1p3*p1p5*p2p3/mw**
     & 2-1d0/6144*p1p5*p2p3*p3p5/mw**2+1d0/6144*p1p5*p2p3**2/mw**2)
     & +iz2up*denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*q
     & up*qdn/s**2/spr*(-1d0/6144*p1p2*p1p3*p3p5/mw**2-1d0/6144*p1p2*p2p
     & 3*p3p5/mw**2+1d0/6144*p1p2*p3p5**2/mw**2+1d0/6144*p1p2*mw**2+1d0/
     & 6144*p1p3*p1p5*p2p3/mw**2-1d0/6144*p1p3*p2p3-1d0/6144*p1p5*p2p3*p
     & 3p5/mw**2+1d0/6144*p1p5*p2p3**2/mw**2+1d0/6144*p2p3**2)
     & +iz2up*denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*q
     & up**2/s**2/spr*(1d0/6144*p1p2*p1p3*p3p5/mw**2+1d0/6144*p1p2*p2p3*
     & p3p5/mw**2-1d0/6144*p1p2*p3p5**2/mw**2-1d0/6144*p1p3*p1p5*p2p3/mw
     & **2+1d0/6144*p1p3*p3p5+1d0/6144*p1p5*p2p3*p3p5/mw**2-1d0/6144*p1p
     & 5*p2p3**2/mw**2-1d0/12288*p1p5*mw**2)
     & +iz3w**2*theta_hard(s,spr,omega)*denw12p*denw12pc*sqrtlssprc*sqrt
     & lsprwh/pi**4*g**6*stw**2/s**2/spr*(1d0/6144*p1p2*mw**4-1d0/3072*p
     & 1p3*p2p3*mw**2-1d0/3072*p1p3*p2p5*mw**2-1d0/3072*p1p5*p2p3*mw**2+
     & 1d0/3072*p1p5*p2p5*mw**2)
     & +iz3w*denw12p*denw34p*denw12pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*s
     & tw**2/s**2/spr*(1d0/6144*p1p2*p1p3*mw**2+1d0/6144*p1p2*p2p3*mw**2
     & -1d0/6144*p1p3*p1p5*p2p3-1d0/6144*p1p3*p2p3*p2p5-1d0/3072*p1p3*p2
     & p3**2+1d0/6144*p1p3*p2p5*mw**2-1d0/3072*p1p3**2*p2p3-1d0/6144*p1p
     & 3**2*p2p5+1d0/6144*p1p5*p2p3*mw**2-1d0/6144*p1p5*p2p3**2-1d0/3072
     & *p1p5*p2p5*mw**2)
     & +iz3w*denw12p*denw12pc*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*
     & stw**2/s**2/spr*(1d0/6144*p1p2*p1p3*mw**2+1d0/6144*p1p2*p2p3*mw**
     & 2-1d0/6144*p1p3*p1p5*p2p3-1d0/6144*p1p3*p2p3*p2p5-1d0/3072*p1p3*p
     & 2p3**2+1d0/6144*p1p3*p2p5*mw**2-1d0/3072*p1p3**2*p2p3-1d0/6144*p1
     & p3**2*p2p5+1d0/6144*p1p5*p2p3*mw**2-1d0/6144*p1p5*p2p3**2-1d0/307
     & 2*p1p5*p2p5*mw**2)
     & +iz3w*denw12p*denw12pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2/s*
     & *2/spr*(1d0/3072*p1p3*p2p3+1d0/6144*p1p3*p2p5+1d0/6144*p1p5*p2p3)
     & 
     & +iz3w*denw12p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2/s*
     & *2/spr*(1d0/12288*p1p2*p1p3+1d0/6144*p1p2*p1p5+1d0/12288*p1p2*p2p
     & 3+1d0/6144*p1p2*p2p5+1d0/12288*p1p3*p1p5*p2p3/mw**2+1d0/12288*p1p
     & 3*p2p3*p2p5/mw**2+1d0/6144*p1p3*p2p3**2/mw**2-1d0/12288*p1p3*p2p5
     & +1d0/6144*p1p3**2*p2p3/mw**2+1d0/12288*p1p3**2*p2p5/mw**2-1d0/122
     & 88*p1p5*p2p3+1d0/12288*p1p5*p2p3**2/mw**2-1d0/6144*p1p5*p2p5)
     & +iz3w*denw12p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qd
     & n/s**2/spr*(1d0/12288*p1p2*p1p3+1d0/6144*p1p2*p1p5+1d0/12288*p1p2
     & *p2p3+1d0/6144*p1p2*p2p5+1d0/12288*p1p3*p1p5*p2p3/mw**2+1d0/12288
     & *p1p3*p2p3*p2p5/mw**2-1d0/12288*p1p3*p2p3+1d0/6144*p1p3*p2p3**2/m
     & w**2-1d0/12288*p1p3*p2p5+1d0/6144*p1p3**2*p2p3/mw**2+1d0/12288*p1
     & p3**2*p2p5/mw**2-1d0/12288*p1p5*p2p3+1d0/12288*p1p5*p2p3**2/mw**2
     & -1d0/6144*p1p5*p2p5+1d0/8192*p2p3*mw**2-1d0/12288*p2p5*mw**2)
     & +iz3w*denw12p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qu
     & p/s**2/spr*(-1d0/12288*p1p2*p1p3-1d0/6144*p1p2*p1p5-1d0/12288*p1p
     & 2*p2p3-1d0/6144*p1p2*p2p5-1d0/12288*p1p3*p1p5*p2p3/mw**2-1d0/1228
     & 8*p1p3*p2p3*p2p5/mw**2+1d0/12288*p1p3*p2p3-1d0/6144*p1p3*p2p3**2/
     & mw**2+1d0/12288*p1p3*p2p5-1d0/8192*p1p3*mw**2-1d0/6144*p1p3**2*p2
     & p3/mw**2-1d0/12288*p1p3**2*p2p5/mw**2+1d0/12288*p1p5*p2p3-1d0/122
     & 88*p1p5*p2p3**2/mw**2+1d0/6144*p1p5*p2p5+1d0/12288*p1p5*mw**2)
     & +iz3w*denw34p*denw12pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2/s*
     & *2/spr*(1d0/12288*p1p2*p1p3+1d0/6144*p1p2*p1p5+1d0/12288*p1p2*p2p
     & 3+1d0/6144*p1p2*p2p5+1d0/12288*p1p3*p1p5*p2p3/mw**2+1d0/12288*p1p
     & 3*p2p3*p2p5/mw**2+1d0/6144*p1p3*p2p3**2/mw**2-1d0/12288*p1p3*p2p5
     & +1d0/6144*p1p3**2*p2p3/mw**2+1d0/12288*p1p3**2*p2p5/mw**2-1d0/122
     & 88*p1p5*p2p3+1d0/12288*p1p5*p2p3**2/mw**2-1d0/6144*p1p5*p2p5)
     & +iz3w*denw34p*denw12pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qd
     & n/s**2/spr*(1d0/12288*p1p2*p1p3+1d0/6144*p1p2*p1p5+1d0/12288*p1p2
     & *p2p3+1d0/6144*p1p2*p2p5+1d0/12288*p1p3*p1p5*p2p3/mw**2+1d0/12288
     & *p1p3*p2p3*p2p5/mw**2-1d0/12288*p1p3*p2p3+1d0/6144*p1p3*p2p3**2/m
     & w**2-1d0/12288*p1p3*p2p5+1d0/6144*p1p3**2*p2p3/mw**2+1d0/12288*p1
     & p3**2*p2p5/mw**2-1d0/12288*p1p5*p2p3+1d0/12288*p1p5*p2p3**2/mw**2
     & -1d0/6144*p1p5*p2p5+1d0/8192*p2p3*mw**2-1d0/12288*p2p5*mw**2)
     & +iz3w*denw34p*denw12pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qu
     & p/s**2/spr*(-1d0/12288*p1p2*p1p3-1d0/6144*p1p2*p1p5-1d0/12288*p1p
     & 2*p2p3-1d0/6144*p1p2*p2p5-1d0/12288*p1p3*p1p5*p2p3/mw**2-1d0/1228
     & 8*p1p3*p2p3*p2p5/mw**2+1d0/12288*p1p3*p2p3-1d0/6144*p1p3*p2p3**2/
     & mw**2+1d0/12288*p1p3*p2p5-1d0/8192*p1p3*mw**2-1d0/6144*p1p3**2*p2
     & p3/mw**2-1d0/12288*p1p3**2*p2p5/mw**2+1d0/12288*p1p5*p2p3-1d0/122
     & 88*p1p5*p2p3**2/mw**2+1d0/6144*p1p5*p2p5+1d0/12288*p1p5*mw**2)
     & +denw12p*denw34p*denw12pc*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g*
     & *6*stw**2/s**2/spr*(1d0/1536*p1p2*p1p3*p2p3-1d0/3072*p1p2*p1p3*p3
     & p5-1d0/3072*p1p2*p2p3*p3p5-1d0/3072*p1p2**2*mw**2+1d0/3072*p1p3*p
     & 1p5*p2p3+1d0/3072*p1p3*p2p3*p2p5-1d0/3072*p1p3*p2p5*p3p5+1d0/3072
     & *p1p3**2*p2p5-1d0/3072*p1p5*p2p3*p3p5+1d0/3072*p1p5*p2p3**2+1d0/3
     & 072*p1p5*p2p5*mw**2)
     & +denw12p*denw34p*denw12pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2
     & /s**2/spr*(-1d0/12288*p1p2*p1p3-1d0/12288*p1p2*p2p3-1d0/6144*p1p3
     & *p2p3-1d0/6144*p1p3*p2p5-1d0/6144*p1p5*p2p3)
     & +denw12p*denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2
     & /s**2/spr*(-1d0/12288*p1p2*p1p3*p3p5/mw**2-1d0/6144*p1p2*p1p5-1d0
     & /12288*p1p2*p2p3*p3p5/mw**2-1d0/6144*p1p2*p2p5+1d0/12288*p1p2*p3p
     & 5**2/mw**2-1d0/12288*p1p3*p1p5*p2p3/mw**2-1d0/12288*p1p3*p2p3*p2p
     & 5/mw**2+1d0/12288*p1p3*p2p5*p3p5/mw**2-1d0/12288*p1p3**2*p2p5/mw*
     & *2+1d0/12288*p1p5*p2p3*p3p5/mw**2-1d0/12288*p1p5*p2p3**2/mw**2+1d
     & 0/6144*p1p5*p2p5)
     & +denw12p*denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2
     & *qdn/s**2/spr*(-1d0/12288*p1p2*p1p3*p3p5/mw**2-1d0/6144*p1p2*p1p5
     & -1d0/12288*p1p2*p2p3*p3p5/mw**2-1d0/6144*p1p2*p2p5+1d0/12288*p1p2
     & *p3p5**2/mw**2-1d0/12288*p1p3*p1p5*p2p3/mw**2-1d0/12288*p1p3*p2p3
     & *p2p5/mw**2+1d0/12288*p1p3*p2p3+1d0/12288*p1p3*p2p5*p3p5/mw**2-1d
     & 0/12288*p1p3**2*p2p5/mw**2+1d0/12288*p1p5*p2p3*p3p5/mw**2-1d0/122
     & 88*p1p5*p2p3**2/mw**2+1d0/6144*p1p5*p2p5-1d0/6144*p2p3*p3p5+1d0/1
     & 2288*p2p3**2+1d0/12288*p2p5*mw**2)
     & +denw12p*denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2
     & *qup/s**2/spr*(1d0/12288*p1p2*p1p3*p3p5/mw**2+1d0/6144*p1p2*p1p5+
     & 1d0/12288*p1p2*p2p3*p3p5/mw**2+1d0/6144*p1p2*p2p5-1d0/12288*p1p2*
     & p3p5**2/mw**2+1d0/12288*p1p3*p1p5*p2p3/mw**2+1d0/12288*p1p3*p2p3*
     & p2p5/mw**2-1d0/12288*p1p3*p2p3-1d0/12288*p1p3*p2p5*p3p5/mw**2+1d0
     & /6144*p1p3*p3p5+1d0/12288*p1p3**2*p2p5/mw**2-1d0/12288*p1p3**2-1d
     & 0/12288*p1p5*p2p3*p3p5/mw**2+1d0/12288*p1p5*p2p3**2/mw**2-1d0/614
     & 4*p1p5*p2p5-1d0/12288*p1p5*mw**2)
     & +denw12p*denw12pc*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**
     & 2/s**2/spr*(-1d0/12288*p1p2*p1p3-1d0/12288*p1p2*p2p3-1d0/6144*p1p
     & 3*p2p3-1d0/6144*p1p3*p2p5-1d0/6144*p1p5*p2p3)
     & +denw12p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2/s**2/sp
     & r*(-1d0/24576*p1p2*p1p3/mw**2-1d0/24576*p1p2*p2p3/mw**2+1d0/24576
     & *p1p2*p3p5/mw**2+1d0/12288*p1p3*p2p3/mw**2+1d0/24576*p1p3*p2p5/mw
     & **2+1d0/24576*p1p5*p2p3/mw**2)
     & +denw12p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qdn/s**
     & 2/spr*(-1d0/24576*p1p2*p1p3/mw**2-1d0/24576*p1p2*p2p3/mw**2+1d0/2
     & 4576*p1p2*p3p5/mw**2+1d0/12288*p1p3*p2p3/mw**2+1d0/24576*p1p3*p2p
     & 5/mw**2+1d0/24576*p1p5*p2p3/mw**2-1d0/12288*p2p3)
     & +denw12p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qup/s**
     & 2/spr*(1d0/24576*p1p2*p1p3/mw**2+1d0/24576*p1p2*p2p3/mw**2-1d0/24
     & 576*p1p2*p3p5/mw**2-1d0/12288*p1p3*p2p3/mw**2-1d0/24576*p1p3*p2p5
     & /mw**2+1d0/12288*p1p3-1d0/24576*p1p5*p2p3/mw**2)
     & +denw34p*denw12pc*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**
     & 2/s**2/spr*(-1d0/12288*p1p2*p1p3*p3p5/mw**2-1d0/6144*p1p2*p1p5-1d
     & 0/12288*p1p2*p2p3*p3p5/mw**2-1d0/6144*p1p2*p2p5+1d0/12288*p1p2*p3
     & p5**2/mw**2-1d0/12288*p1p3*p1p5*p2p3/mw**2-1d0/12288*p1p3*p2p3*p2
     & p5/mw**2+1d0/12288*p1p3*p2p5*p3p5/mw**2-1d0/12288*p1p3**2*p2p5/mw
     & **2+1d0/12288*p1p5*p2p3*p3p5/mw**2-1d0/12288*p1p5*p2p3**2/mw**2+1
     & d0/6144*p1p5*p2p5)
     & +denw34p*denw12pc*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**
     & 2*qdn/s**2/spr*(-1d0/12288*p1p2*p1p3*p3p5/mw**2-1d0/6144*p1p2*p1p
     & 5-1d0/12288*p1p2*p2p3*p3p5/mw**2-1d0/6144*p1p2*p2p5+1d0/12288*p1p
     & 2*p3p5**2/mw**2-1d0/12288*p1p3*p1p5*p2p3/mw**2-1d0/12288*p1p3*p2p
     & 3*p2p5/mw**2+1d0/12288*p1p3*p2p3+1d0/12288*p1p3*p2p5*p3p5/mw**2-1
     & d0/12288*p1p3**2*p2p5/mw**2+1d0/12288*p1p5*p2p3*p3p5/mw**2-1d0/12
     & 288*p1p5*p2p3**2/mw**2+1d0/6144*p1p5*p2p5-1d0/6144*p2p3*p3p5+1d0/
     & 12288*p2p3**2+1d0/12288*p2p5*mw**2)
     & +denw34p*denw12pc*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**
     & 2*qup/s**2/spr*(1d0/12288*p1p2*p1p3*p3p5/mw**2+1d0/6144*p1p2*p1p5
     & +1d0/12288*p1p2*p2p3*p3p5/mw**2+1d0/6144*p1p2*p2p5-1d0/12288*p1p2
     & *p3p5**2/mw**2+1d0/12288*p1p3*p1p5*p2p3/mw**2+1d0/12288*p1p3*p2p3
     & *p2p5/mw**2-1d0/12288*p1p3*p2p3-1d0/12288*p1p3*p2p5*p3p5/mw**2+1d
     & 0/6144*p1p3*p3p5+1d0/12288*p1p3**2*p2p5/mw**2-1d0/12288*p1p3**2-1
     & d0/12288*p1p5*p2p3*p3p5/mw**2+1d0/12288*p1p5*p2p3**2/mw**2-1d0/61
     & 44*p1p5*p2p5-1d0/12288*p1p5*mw**2)
     & +denw34p*denw12pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2/s**2/sp
     & r*(-1d0/24576*p1p2*p1p3/mw**2-1d0/24576*p1p2*p2p3/mw**2+1d0/24576
     & *p1p2*p3p5/mw**2+1d0/12288*p1p3*p2p3/mw**2+1d0/24576*p1p3*p2p5/mw
     & **2+1d0/24576*p1p5*p2p3/mw**2)
     & +denw34p*denw12pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qdn/s**
     & 2/spr*(-1d0/24576*p1p2*p1p3/mw**2-1d0/24576*p1p2*p2p3/mw**2+1d0/2
     & 4576*p1p2*p3p5/mw**2+1d0/12288*p1p3*p2p3/mw**2+1d0/24576*p1p3*p2p
     & 5/mw**2+1d0/24576*p1p5*p2p3/mw**2-1d0/12288*p2p3)
     & +denw34p*denw12pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qup/s**
     & 2/spr*(1d0/24576*p1p2*p1p3/mw**2+1d0/24576*p1p2*p2p3/mw**2-1d0/24
     & 576*p1p2*p3p5/mw**2-1d0/12288*p1p3*p2p3/mw**2-1d0/24576*p1p3*p2p5
     & /mw**2+1d0/12288*p1p3-1d0/24576*p1p5*p2p3/mw**2)
     & +denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2/s**2/sp
     & r*(-1d0/6144*p1p2*p1p3*p2p3/mw**4+1d0/6144*p1p2*p1p3*p3p5/mw**4-1
     & d0/12288*p1p2*p1p3**2/mw**4+1d0/6144*p1p2*p1p5/mw**2+1d0/6144*p1p
     & 2*p2p3*p3p5/mw**4-1d0/12288*p1p2*p2p3**2/mw**4+1d0/6144*p1p2*p2p5
     & /mw**2-1d0/12288*p1p2*p3p5**2/mw**4-1d0/6144*p1p2**2/mw**2)
     & +denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qdn/s**
     & 2/spr*(-1d0/3072*p1p2*p1p3*p2p3/mw**4+1d0/3072*p1p2*p1p3*p3p5/mw*
     & *4-1d0/6144*p1p2*p1p3**2/mw**4+1d0/3072*p1p2*p1p5/mw**2+1d0/3072*
     & p1p2*p2p3*p3p5/mw**4-1d0/6144*p1p2*p2p3**2/mw**4+1d0/3072*p1p2*p2
     & p5/mw**2-1d0/6144*p1p2*p3p5**2/mw**4-1d0/6144*p1p2-1d0/3072*p1p2*
     & *2/mw**2-1d0/12288*p1p3*p2p3/mw**2+1d0/12288*p2p3*p3p5/mw**2-1d0/
     & 12288*p2p3**2/mw**2)
     & +denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qdn**2/
     & s**2/spr*(-1d0/6144*p1p2*p1p3*p2p3/mw**4+1d0/6144*p1p2*p1p3*p3p5/
     & mw**4-1d0/12288*p1p2*p1p3**2/mw**4+1d0/6144*p1p2*p1p5/mw**2+1d0/6
     & 144*p1p2*p2p3*p3p5/mw**4-1d0/12288*p1p2*p2p3**2/mw**4+1d0/6144*p1
     & p2*p2p5/mw**2-1d0/12288*p1p2*p3p5**2/mw**4-1d0/6144*p1p2-1d0/6144
     & *p1p2**2/mw**2-1d0/12288*p1p3*p2p3/mw**2+1d0/12288*p2p3*p3p5/mw**
     & 2-1d0/12288*p2p3**2/mw**2)
     & +denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qup/s**
     & 2/spr*(1d0/3072*p1p2*p1p3*p2p3/mw**4-1d0/3072*p1p2*p1p3*p3p5/mw**
     & 4+1d0/6144*p1p2*p1p3**2/mw**4-1d0/3072*p1p2*p1p5/mw**2-1d0/3072*p
     & 1p2*p2p3*p3p5/mw**4+1d0/6144*p1p2*p2p3**2/mw**4-1d0/3072*p1p2*p2p
     & 5/mw**2+1d0/6144*p1p2*p3p5**2/mw**4+1d0/6144*p1p2+1d0/3072*p1p2**
     & 2/mw**2+1d0/12288*p1p3*p2p3/mw**2-1d0/12288*p1p3*p3p5/mw**2+1d0/1
     & 2288*p1p3**2/mw**2)
     & +denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qup*qdn
     & /s**2/spr*(1d0/3072*p1p2*p1p3*p2p3/mw**4-1d0/3072*p1p2*p1p3*p3p5/
     & mw**4+1d0/6144*p1p2*p1p3**2/mw**4-1d0/3072*p1p2*p1p5/mw**2-1d0/30
     & 72*p1p2*p2p3*p3p5/mw**4+1d0/6144*p1p2*p2p3**2/mw**4-1d0/3072*p1p2
     & *p2p5/mw**2+1d0/6144*p1p2*p3p5**2/mw**4+1d0/3072*p1p2+1d0/3072*p1
     & p2**2/mw**2+1d0/6144*p1p3*p2p3/mw**2-1d0/12288*p1p3*p3p5/mw**2+1d
     & 0/12288*p1p3**2/mw**2-1d0/12288*p2p3*p3p5/mw**2+1d0/12288*p2p3**2
     & /mw**2)
     & +denw34p*denw34pc*sqrtlssprc*sqrtlsprwh/pi**4*g**6*stw**2*qup**2/
     & s**2/spr*(-1d0/6144*p1p2*p1p3*p2p3/mw**4+1d0/6144*p1p2*p1p3*p3p5/
     & mw**4-1d0/12288*p1p2*p1p3**2/mw**4+1d0/6144*p1p2*p1p5/mw**2+1d0/6
     & 144*p1p2*p2p3*p3p5/mw**4-1d0/12288*p1p2*p2p3**2/mw**4+1d0/6144*p1
     & p2*p2p5/mw**2-1d0/12288*p1p2*p3p5**2/mw**4-1d0/6144*p1p2-1d0/6144
     & *p1p2**2/mw**2-1d0/12288*p1p3*p2p3/mw**2+1d0/12288*p1p3*p3p5/mw**
     & 2-1d0/12288*p1p3**2/mw**2)

      hard = hard*conhc*cfprime

      return
      end
