************************************************************************
* sanc_cc_v1.40 package.
************************************************************************
* File (cc_br_2122_1516.f) is created on Tue Aug  9 22:42:11 MSD 2011.
************************************************************************
* This is the FORTRAN module (cc_bo_2122_1516) to calculate EW
* integrated Born width for the anti-tp -> anti-bt + mn + mo^- decay.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2011.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_bo_2122_1516 (s,born)
      implicit none!
      include 's2n_declare.h'

      real*8 sqrtlstpbt
      complex*16 propws,propiws,propwsc

      cmw2 = mw2

      if (irun.eq.0) then
         propiws = (cmw2-s)
      elseif (irun.eq.1) then
         propiws = (dcmplx(mw**2,-s*ww/mw)-s)
      endif
      propws = 1d0/propiws
      propwsc = dconjg(propws)

      sqrtlstpbt = dsqrt((s-mtp**2-mbt**2)**2-4d0*mtp**2*mbt**2)

      born=
     & +sqrtlstpbt*propws*propwsc/pi**3*gf**2*mw**4*(-1d0/48/mtp**3*s**2
     & +1d0/96/mtp**3*mbt**2*s+1d0/96/mtp**3*mbt**4+1d0/96/mtp*s-1d0/48/
     & mtp*mbt**2+1d0/96*mtp)

      return
      end
************************************************************************
* This is the FORTRAN module (cc_br_2122_1516) to calculate EW Born
* width and soft photon Bremsstrahlung
* for the anti-tp -> anti-bt + mn + mo^- decay.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2011.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_br_2122_1516 (qs,ts,us,born,soft,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 qw,softvirtisr,softvirtfsr,softvirtifi
      real*8 sqrtlstpbt,isqrtlstpbt
      real*8 betatpsbt,ibetatpsbt,betatpjsbt,ibetatpjsbt
      real*8 betatpbts,ibetatpbts,umin,umax
      real*8 jbwtpbtsq,jbwbttpsq
      complex*16 propws,propiws,propwsc

      cmw2 = mw2
      qw   = 1d0

      s = -qs
      t = -ts
      u = -us

      sqrtlstpbt = dsqrt((s-mtp**2-mbt**2)**2-4d0*mtp**2*mbt**2)
      isqrtlstpbt = 1d0/sqrtlstpbt

      cosf = (u-t)/sqrtlstpbt
      sinf = dsqrt(1d0-cosf**2)

      if (irun.eq.0) then
         propiws = (cmw2-s)
      elseif (irun.eq.1) then
         propiws = (dcmplx(mw**2,-s*ww/mw)-s)
      endif
      propws = 1d0/propiws
      propwsc = dconjg(propws)

      born=
     & +propws*propwsc/pi**3*gf**2*mw**4*(-1d0/16/mtp**3*u**2+1d0/16/mtp
     & **3*mbt**2*u+1d0/16/mtp*u-1d0/16/mtp*mbt**2)

      born = born*sqrtlstpbt/2d0
      virt = 0d0
      soft = 0d0
      hard = 0d0

      if (iborn.eq.1) return

      betatpjsbt = sqrtlstpbt/(rtpm2-s-rbtm2)
      ibetatpjsbt = 1d0/betatpjsbt

      betatpsbt = sqrtlstpbt/(rtpm2+s-rbtm2)
      ibetatpsbt = 1d0/betatpsbt

      betatpbts = sqrtlstpbt/(rtpm2+rbtm2-s)
      ibetatpbts = 1d0/betatpbts

      jbwbttpsq = log((rtpm2-rbtm2+s-sqrtlstpbt)/(rtpm2-rbtm2+s+sqrtlstpbt))
      jbwtpbtsq = log((rtpm2-rbtm2-s+sqrtlstpbt)/(rtpm2-rbtm2-s-sqrtlstpbt))

      umin = (rtpm2+rbtm2-s-sqrtlstpbt)/2d0
      umax = (rtpm2+rbtm2-s+sqrtlstpbt)/2d0

      softvirtisr=
     & +born/pi*alpha*qbt**2*(3d0/4)
     & +born/pi*alpha*qtp**2*(3d0/4)
     & +isqrtlstpbt*log(4*omega**2/mtp**2)*born/pi*alpha*qtp*qbt*(-1d0/2
     & *jbwbttpsq*s+1d0/2*jbwbttpsq*mbt**2+1d0/2*jbwbttpsq*mtp**2-1d0/2*
     & jbwtpbtsq*s+1d0/2*jbwtpbtsq*mbt**2+1d0/2*jbwtpbtsq*mtp**2)
     & +ibetatpjsbt*born/pi*alpha*qbt**2*(1d0/2*jbwtpbtsq)
     & +ibetatpbts*born/pi*alpha*qtp*qbt*(1d0/2*jbwbttpsq**2-1d0/2*jbwtp
     & btsq**2)
     & +ibetatpbts*log(1d0/mtp**2*mbt**2)*born/pi*alpha*qtp*qbt*(-1d0/2*
     & jbwtpbtsq)
     & +ibetatpbts*ddilog(2/(1+betatpjsbt)*betatpjsbt)*born/pi*alpha*qtp
     & *qbt*(-2)
     & +ibetatpbts*ddilog(2/(1+betatpsbt)*betatpsbt)*born/pi*alpha*qtp*q
     & bt*(2)
     & +ibetatpsbt*born/pi*alpha*qtp**2*(-1d0/2*jbwbttpsq)
     & +log(mtp**2/thmu2)*born/pi*alpha*qbt**2*(-3d0/4)
     & +log(mtp**2/thmu2)*born/pi*alpha*qtp**2*(-3d0/4)
     & +log(1d0/mtp**2*mbt**2)*born/pi*alpha*qbt**2*(-1d0/4)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qbt**2*(-1d0/2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*qtp**2*(-1d0/2)

      softvirtfsr=
     & +born/pi*alpha*(3d0/4*qmo**2)
     & +log(mtp**2/thmu2)*born/pi*alpha*(-3d0/4*qmo**2)
     & +log(1d0/mtp**2*s)*born/pi*alpha*(1d0/2*qmo**2)
     & +log(mmo**2/mtp**2)*born/pi*alpha*(-3d0/4*qmo**2)
     & +log(4*omega**2/mtp**2)*born/pi*alpha*(-1d0/2*qmo**2)

      softvirtifi=
     & +born/pi*alpha*qw*qbt*(1d0/4*jbwtpbtsq**2)
     & +born/pi*alpha*qw*qtp*(-1d0/4*jbwbttpsq**2)
     & +log(-1+1d0/mbt**2*t)**2*born/pi*alpha*qbt*(-qmo)
     & +log(1-1d0/mtp**2*u)**2*born/pi*alpha*qtp*(qmo)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qbt*(-1d0/4*qmo)
     & +log(1d0/mtp**2*s)**2*born/pi*alpha*qtp*(1d0/4*qmo)
     & +log(1d0/mtp**2*mbt**2)*log(-1+1d0/mbt**2*t)*born/pi*alpha*qbt*(-
     & qmo)
     & +log(1d0/mtp**2*mbt**2)**2*born/pi*alpha*qbt*(-1d0/4*qmo)
     & +log(1d0/mbt**2*t)**2*born/pi*alpha*qbt*(1d0/2*qmo)
     & +log(mmo**2/mtp**2)*log(1d0/mtp**2*s)*born/pi*alpha*(1d0/2*qmo**2
     & )
     & +log(4*omega**2/mtp**2)*log(-1+1d0/mbt**2*t)*born/pi*alpha*qbt*(q
     & mo)
     & +log(4*omega**2/mtp**2)*log(1-1d0/mtp**2*u)*born/pi*alpha*qtp*(-q
     & mo)
     & +log(4*omega**2/mtp**2)*log(1d0/mtp**2*mbt**2)*born/pi*alpha*qbt*
     & (1d0/2*qmo)
     & +log(4*omega**2/mtp**2)*log(mmo**2/mtp**2)*born/pi*alpha*(-1d0/2*
     & qmo**2)
     & +ddilog(1d0/mtp**2*u)*born/pi*alpha*qtp*(qmo)
     & +ddilog(mbt**2/t)*born/pi*alpha*qbt*(qmo)
     & +ddilog(-1/(-u+mtp**2)*u+1/(-u+mtp**2)*umin)*born/pi*alpha*qtp*(q
     & mo)
     & +ddilog(-1/(-u+mtp**2)*u+1/(-u+mtp**2)*umax)*born/pi*alpha*qtp*(q
     & mo)
     & +ddilog(1/(t-mbt**2)*t-1/(t-mbt**2)*umin)*born/pi*alpha*qbt*(-qmo
     & )
     & +ddilog(1/(t-mbt**2)*t-1/(t-mbt**2)*umax)*born/pi*alpha*qbt*(-qmo
     & )
     & +ddilog(1d0)*born/pi*alpha*qbt*(3*qmo)
     & +ddilog(1d0)*born/pi*alpha*qtp*(qmo)

      if (iqed.eq.1) then
         soft = softvirtisr+softvirtfsr+softvirtifi
      elseif(iqed.eq.2) then
         soft = softvirtisr
      elseif(iqed.eq.3) then
         soft = softvirtifi
      elseif(iqed.eq.4) then
         soft = softvirtfsr
      endif

      soft = soft*cfprime

      return
      end
