************************************************************************
* sanc_cc_v1.40 package.
************************************************************************
* File (cc-qcd_br_1314_2122.f) is created on Tue Aug  9 22:48:57 MSD 2011.
************************************************************************
* This is the FORTRAN module (cc_qcd_br_1314_2122) to calculate EW Born
* cross section and QCD virtual corrections 
* for the anti-up + dn -> anti-tp + bt process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2011.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_qcd_br_1314_2122 (qs,ts,us,born,soft,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 softvirtisr,softvirtfsr
      real*8 jbwbttpsq,jbwtpbtsq
      real*8 sqrtlstpbt,sqrtlsbttp,isqrtlstpbt
      real*8 betasbttp,ibetasbttp
      real*8 b0ptpctp
      complex*16 c0wtpbtqs
      complex*16 propws,propiws,propwsc

      cmw2 = mw2

      s = -qs
      t = -ts
      u = -us

      sqrtlstpbt = dsqrt((s-mtp**2-mbt**2)**2-4d0*mtp**2*mbt**2)
      sqrtlsbttp = sqrtlstpbt
      isqrtlstpbt = 1d0/sqrtlstpbt

      cosf = (u-t)/sqrtlstpbt
      sinf = dsqrt(1d0-cosf**2)

      if (irun.eq.0) then
         propiws = (cmw2-s)
      elseif (irun.eq.1) then
         propiws = (dcmplx(mw**2,-s*ww/mw)-s)
      endif
      propws = 1d0/propiws
      propwsc = dconjg(propws)

      born=
     & +sqrtlstpbt**3*propws*propwsc/pi*gf**2*mw**4/s**2*(1d0/16*cosf**2
     & )
     & +sqrtlstpbt**2*propws*propwsc/pi*gf**2*mw**4/s*(-1d0/8*cosf)
     & +sqrtlstpbt*propws*propwsc/pi*gf**2*mw**4/s**2*(-1d0/16*mbt**4+1d
     & 0/8*mtp**2*mbt**2-1d0/16*mtp**4)
     & +sqrtlstpbt*propws*propwsc/pi*gf**2*mw**4*(1d0/16)

      born = born*conhc
      virt = 0d0
      soft = 0d0
      hard = 0d0

      if (iborn.eq.1) return

      born = born/conhc

      betasbttp = sqrtlstpbt/(s+mbt**2-mtp**2)
      ibetasbttp = 1d0/betasbttp

      jbwbttpsq =
     &    log((mtp**2-mbt**2+s-sqrtlstpbt)/(mtp**2-mbt**2+s+sqrtlstpbt))
      jbwtpbtsq =
     &    log((mtp**2-mbt**2-s+sqrtlstpbt)/(mtp**2-mbt**2-s-sqrtlstpbt))

      b0ptpctp  = 1d0/mtp**2*log(wtp/mtp)
      c0wtpbtqs = c0analys(mtp,mbt,wtp,qs)

      softvirtisr=
     & +born/pi*alphas*cf*(-2)
     & +log(1d0/mup**2*s)*born/pi*alphas*cf*(3d0/4)
     & +log(1d0/mdn**2*s)*born/pi*alphas*cf*(3d0/4)
     & +log(4*omega**2/s)*born/pi*alphas*cf*(-1)
     & +log(4*omega**2/s)*log(1d0/mup**2*s)*born/pi*alphas*cf*(1d0/2)
     & +log(4*omega**2/s)*log(1d0/mdn**2*s)*born/pi*alphas*cf*(1d0/2)
     & +ddilog(1d0)*born/pi*alphas*cf*(2)

      softvirtfsr=
     & +born/pi*alphas*cf*(-1)
     & +sqrtlstpbt**2*propws*propwsc*log(1d0/mtp**2*s)/pi**2*alphas*gf**
     & 2*mw**4*cf*(-1d0/32*cosf*mbt**2/s**2+1d0/32*cosf*mtp**2/s**2)
     & +sqrtlstpbt**2*propws*propwsc*log(1d0/mbt**2*s)/pi**2*alphas*gf**
     & 2*mw**4*cf*(1d0/32*cosf*mbt**2/s**2-1d0/32*cosf*mtp**2/s**2)
     & +sqrtlstpbt*propws*propwsc*log(1d0/mtp**2*s)/pi**2*alphas*gf**2*m
     & w**4*cf*(1d0/32*mbt**2/s-1d0/32*mbt**4/s**2-1d0/32*mtp**2/s+1d0/3
     & 2*mtp**4/s**2)
     & +sqrtlstpbt*propws*propwsc*log(1d0/mbt**2*s)/pi**2*alphas*gf**2*m
     & w**4*cf*(-1d0/32*mbt**2/s+1d0/32*mbt**4/s**2+1d0/32*mtp**2/s-1d0/
     & 32*mtp**4/s**2)
     & +sqrtlstpbt*propws*propwsc*jbwbttpsq/pi**2*alphas*gf**2*mw**4*cf*
     & (-1d0/32*cosf*mbt**2/s+1d0/32*cosf*mbt**4/s**2-1d0/32*cosf*mtp**2
     & /s-1d0/16*cosf*mtp**2*mbt**2/s**2+1d0/32*cosf*mtp**4/s**2)
     & +sqrtlstpbt*propws*propwsc*jbwtpbtsq/pi**2*alphas*gf**2*mw**4*cf*
     & (-1d0/32*cosf*mbt**2/s+1d0/32*cosf*mbt**4/s**2-1d0/32*cosf*mtp**2
     & /s-1d0/16*cosf*mtp**2*mbt**2/s**2+1d0/32*cosf*mtp**4/s**2)
     & +sqrtlstpbt*jbwbttpsq*born/pi*alphas*cf*(-3d0/4/s)
     & +sqrtlstpbt*jbwtpbtsq*born/pi*alphas*cf*(-3d0/4/s)
     & +isqrtlstpbt*jbwbttpsq*born/pi*alphas*cf*(-3d0/4*mbt**2+3d0/4*mbt
     & **4/s-3d0/4*mtp**2-3d0/2*mtp**2*mbt**2/s+3d0/4*mtp**4/s)
     & +isqrtlstpbt*jbwtpbtsq*born/pi*alphas*cf*(-3d0/4*mbt**2+3d0/4*mbt
     & **4/s-3d0/4*mtp**2-3d0/2*mtp**2*mbt**2/s+3d0/4*mtp**4/s)
     & +ibetasbttp*jbwtpbtsq*born/pi*alphas*cf*(-1d0/2)
     & +propws*propwsc*jbwbttpsq/pi**2*alphas*gf**2*mw**4*cf*(1d0/32*mbt
     & **2-1d0/16*mbt**4/s+1d0/32*mbt**6/s**2+1d0/32*mtp**2+1d0/4*mtp**2
     & *mbt**2/s-1d0/32*mtp**2*mbt**4/s**2-1d0/16*mtp**4/s-1d0/32*mtp**4
     & *mbt**2/s**2+1d0/32*mtp**6/s**2)
     & +propws*propwsc*jbwtpbtsq/pi**2*alphas*gf**2*mw**4*cf*(1d0/32*mbt
     & **2-1d0/16*mbt**4/s+1d0/32*mbt**6/s**2+1d0/32*mtp**2+1d0/4*mtp**2
     & *mbt**2/s-1d0/32*mtp**2*mbt**4/s**2-1d0/16*mtp**4/s-1d0/32*mtp**4
     & *mbt**2/s**2+1d0/32*mtp**6/s**2)
     & +b0ptpctp*born/pi*alphas*cf*(-mtp**2)
     & +c0wtpbtqs*born/pi*alphas*cf*(s-mbt**2-mtp**2)
     & +log(1d0/mbt**2*s)*born/pi*alphas*cf*(-1d0/2)
     & +log(4*omega**2/s)*born/pi*alphas*cf*(-1d0/2)

      soft = softvirtisr+softvirtfsr
      soft = soft*conhc

      return
      end
************************************************************************
* This is the FORTRAN module (cc_qcd_ha_1314_2122_1spr) to calculate hard
* gluon radiation for the anti-up + dn -> anti-tp + bt process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2011.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_qcd_ha_1314_2122_1spr (s,spr,hard)
      implicit none!
      include 's2n_declare.h'

      real*8 sq,sqspr
      real*8 bornints,bornintspr
      real*8 betasjtpbt,ibetasjtpbt
      real*8 sqrtlsprtpbt,sqrtlsprbttp,isqrtlsprtpbt
      real*8 sqrtlstpbt,sqrtlsbttp,isqrtlstpbt

      complex*16 propiws,propws,propwsc,propiwspr,propwspr,propwsprc
      real*8 jbwtpbtsqspr
      complex*16 jbwbttpsqspr

      external cc_bo_1314_2122

      cmw2 = mw2
      sq = dsqrt(s)
      sqspr = dsqrt(spr)

      sqrtlstpbt = dsqrt((s-mtp**2-mbt**2)**2-4d0*mtp**2*mbt**2)
      sqrtlsbttp = sqrtlstpbt
      isqrtlstpbt = 1d0/sqrtlstpbt

      sqrtlsprtpbt = dsqrt((spr-mtp**2-mbt**2)**2-4d0*mtp**2*mbt**2)
      sqrtlsprbttp = sqrtlsprtpbt
      isqrtlsprtpbt = 1d0/sqrtlsprtpbt

      betasjtpbt = sqrtlstpbt/(s-mtp**2-mbt**2)
      ibetasjtpbt = 1d0/betasjtpbt

      if (irun.eq.0) then
         propiws = (cmw2-s)
         propiwspr = (cmw2-spr)
      elseif (irun.eq.1) then
         propiws = (dcmplx(mw**2,-s*ww/mw)-s)
         propiwspr = (dcmplx(mw**2,-spr*ww/mw)-spr)
      endif
      propws = 1d0/propiws
      propwsc = dconjg(propws)
      propwspr = 1d0/propiwspr
      propwsprc = dconjg(propwspr)

      jbwbttpsqspr =
     & log((2*i_*gtp*spr+(s-spr)*(spr+mtp**2-mbt**2-sqrtlsprtpbt))
     &    /(2*i_*gtp*spr+(s-spr)*(spr+mtp**2-mbt**2+sqrtlsprtpbt)))

      jbwtpbtsqspr =
     &    log((mtp**2-mbt**2-spr+sqrtlsprtpbt)/(mtp**2-mbt**2-spr-sqrtlsprtpbt))

      call cc_bo_1314_2122 (s,bornints)
      bornints = bornints/conhc

      call cc_bo_1314_2122 (spr,bornintspr)
      bornintspr = bornintspr/conhc

      hardisr=
     & +bornintspr*(s**2+spr**2)/pi*alphas/(s-spr)*theta_hard(s,spr,omeg
     & a)*cf*(-1d0/s**2)
     & +bornintspr*log(1d0/mup**2*s)*(s**2+spr**2)/pi*alphas/(s-spr)*the
     & ta_hard(s,spr,omega)*cf*(1d0/2/s**2)
     & +bornintspr*log(1d0/mdn**2*s)*(s**2+spr**2)/pi*alphas/(s-spr)*the
     & ta_hard(s,spr,omega)*cf*(1d0/2/s**2)

      hardfsr=
     & +bornints*sqrtlsprtpbt*isqrtlstpbt/pi*alphas/(s-spr)*theta_hard(s
     & ,spr,omega)*cf*(-1)
     & +bornints*isqrtlstpbt*dreal(jbwbttpsqspr)*(1d0/(s-spr+i_*gtp)
     & +1d0/(s-spr-i_*gtp))/pi*alphas*cf*(-1d0/2*s+1d0/2*mbt**2+1d0/2*mt
     & p**2)
     & +bornints*isqrtlstpbt*jbwtpbtsqspr*(1d0/(s-spr+i_*gtp)
     & +1d0/(s-spr-i_*gtp))/pi*alphas*cf*(-1d0/2*s+1d0/2*mbt**2+1d0/2*mt
     & p**2)
     & +bornints*isqrtlstpbt*dimag(jbwbttpsqspr)/gtp/pi*alphas*cf*(-mtp*
     & *2)
     & +bornints*isqrtlstpbt*dimag(jbwbttpsqspr)*i_*(1d0/(s-spr+i_*gtp)
     & -1d0/(s-spr-i_*gtp))/pi*alphas*cf*(-1d0/2*s+1d0/2*mbt**2+1d0/2*mt
     & p**2)
     & +sqrtlsprtpbt*propws*propwsc/pi**2*alphas*gf**2*mw**4*(s-spr)*cf*
     & (-1d0/6/s/spr)
     & +propws*propwsc*dreal(jbwbttpsqspr)/pi**2*alphas*gf**2*mw**4*cf*(
     & -1d0/12*mbt**2/s-1d0/6*mbt**4/s**2+1d0/6*mtp**2*mbt**2/s**2)
     & +propws*propwsc*dreal(jbwbttpsqspr)/pi**2*alphas*gf**2*mw**4*(s-s
     & pr)*cf*(-1d0/12/s+1d0/24*mbt**2/s**2-1d0/24*mtp**2/s**2)
     & +propws*propwsc*dreal(jbwbttpsqspr)*(1d0/(s-spr+i_*gtp)
     & +1d0/(s-spr-i_*gtp))/pi**2*alphas*gf**2*mw**4*(s-spr)*cf*(1d0/12+
     & 1d0/24*mbt**4/s**2-1d0/24*mtp**2/s-1d0/24*mtp**4/s**2)
     & +propws*propwsc*dreal(jbwbttpsqspr)*(1d0/(s-spr+i_*gtp)
     & +1d0/(s-spr-i_*gtp))/pi**2*alphas*gf**2*mw**4*(s-spr)**2*cf*(-1d0
     & /24*mbt**2/s**2)
     & +propws*propwsc*jbwtpbtsqspr/pi**2*alphas*gf**2*mw**4*cf*(-1d0/12
     & *mbt**2/s-1d0/6*mbt**4/s**2+1d0/6*mtp**2*mbt**2/s**2)
     & +propws*propwsc*jbwtpbtsqspr/pi**2*alphas*gf**2*mw**4*(s-spr)*cf*
     & (-1d0/12/s+1d0/24*mbt**2/s**2-1d0/24*mtp**2/s**2)
     & +propws*propwsc*jbwtpbtsqspr*(1d0/(s-spr+i_*gtp)
     & +1d0/(s-spr-i_*gtp))/pi**2*alphas*gf**2*mw**4*(s-spr)*cf*(1d0/12+
     & 1d0/24*mbt**4/s**2-1d0/24*mtp**2/s-1d0/24*mtp**4/s**2)
     & +propws*propwsc*jbwtpbtsqspr*(1d0/(s-spr+i_*gtp)
     & +1d0/(s-spr-i_*gtp))/pi**2*alphas*gf**2*mw**4*(s-spr)**2*cf*(-1d0
     & /24*mbt**2/s**2)
     & +propws*propwsc*dimag(jbwbttpsqspr)*gtp/pi**2*alphas*gf**2*mw**4*
     & cf*(1d0/8/s+1d0/12*mbt**2/s**2)
     & +propws*propwsc*dimag(jbwbttpsqspr)*gtp/pi**2*alphas*gf**2*mw**4*
     & (s-spr)*cf*(-1d0/24/s**2)
     & +propws*propwsc*dimag(jbwbttpsqspr)*gtp*(1d0/(s-spr+i_*gtp)
     & +1d0/(s-spr-i_*gtp))/pi**2*alphas*gf**2*mw**4*cf*(1d0/12+1d0/24*m
     & bt**4/s**2-1d0/24*mtp**2/s-1d0/24*mtp**4/s**2)
     & +propws*propwsc*dimag(jbwbttpsqspr)*gtp*(1d0/(s-spr+i_*gtp)
     & +1d0/(s-spr-i_*gtp))/pi**2*alphas*gf**2*mw**4*(s-spr)*cf*(-1d0/24
     & *mbt**2/s**2)

      hard = hardisr+hardfsr
      hard = hard*conhc

      return
      end
